--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.QPixmap       ;      use Qt.QPixmap;
with Qt.QImage        ;      use Qt.QImage;
with Qt.QGraphicsPixmapItem; use Qt.QGraphicsPixmapItem;
with Qt.QGraphicsView;      use  Qt.QGraphicsView;
 
package  body Qt.OpenCV is
 
 function  QOpenCV_imdecode(buf:QCVMatH;flags: ImreadModes;dst: QCVMatH) return QCVMatH is
 begin
   return QOpenCV_imdecode2(buf,flags,dst);
 end;
 
 procedure QOpenCV_imshow(frame: not null QCVMatH;graphicsView : not null QGraphicsViewH) is 
 qimg        : QImageH;
 pixmap      : QGraphicsPixmapItemH := QGraphicsPixmapItem_create;
 
 function  QCVMat_toQImage(handle:not null QCVMatH) return QImageH;
 pragma Import(C,QCVMat_toQImage, "QCVMat_toQImage");

 begin
  qimg := QCVMat_toQImage(frame);        
  QGraphicsPixmapItem_setPixmap(pixmap,QPixmap_fromImage(QImage_rgbSwapped(qimg)));        
  QGraphicsView_fitInView(QAbstractScrollAreaH(graphicsView),QGraphicsItemH(pixmap), QtKeepAspectRatio); 
  
 end;

 
end;
