--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;
with Qt.QCVCore; use Qt.QCVCore;
package Qt.QCVCascadeClassifier is

 CASCADE_DO_CANNY_PRUNING    : constant := 1;
 CASCADE_SCALE_IMAGE         : constant := 2;
 CASCADE_FIND_BIGGEST_OBJECT : constant := 4;
 CASCADE_DO_ROUGH_SEARCH     : constant := 8;

 function  QCVCascadeClassifier_create return QCVCascadeClassifierH;
 pragma Import(C,QCVCascadeClassifier_create, "QCVCascadeClassifier_create");
 
 function  QCVCascadeClassifier_create2(fileName:QStringH) return QCVCascadeClassifierH;
 pragma Import(C,QCVCascadeClassifier_create2, "QCVCascadeClassifier_create2");
 
 procedure QCVCascadeClassifier_destroy(handle:not null QCVCascadeClassifierH);
 pragma Import(C,QCVCascadeClassifier_destroy, "QCVCascadeClassifier_destroy");
 
 function  QCVCascadeClassifier_empty(handle:not null QCVCascadeClassifierH) return boolean;
 pragma Import(C,QCVCascadeClassifier_empty, "QCVCascadeClassifier_empty");
 
 function  QCVCascadeClassifier_load(handle:not null QCVCascadeClassifierH;fileName:QStringH) return boolean;
 pragma Import(C,QCVCascadeClassifier_load, "QCVCascadeClassifier_load");
 
 function  QCVCascadeClassifier_read(handle:not null QCVCascadeClassifierH;node :QCVFileNodeH) return boolean;
 pragma Import(C,QCVCascadeClassifier_read, "QCVCascadeClassifier_read");
 
 procedure QCVCascadeClassifier_detectMultiScale(handle:not null QCVCascadeClassifierH;frame:QCVMatH;objects:QCVFacesH;scaleFactor :qreal :=  1.1;minNeighbors :integer :=  3;flags : int :=  0;minSize :QCVSizeH := QCVSize_create;maxSize :QCVSizeH := QCVSize_create);
 pragma Import(C,QCVCascadeClassifier_detectMultiScale, "QCVCascadeClassifier_detectMultiScale");
 
 procedure QCVCascadeClassifier_detectMultiScale2(handle:not null QCVCascadeClassifierH;frame: QCVMatH;objects:QCVFacesH;numDetections:QCVLabelsH;scaleFactor:qreal := 1.1;minNeighbors:integer := 3;flags: integer := 0;minSize :QCVSizeH := QCVSize_create;maxSize :QCVSizeH := QCVSize_create);
 pragma Import(C,QCVCascadeClassifier_detectMultiScale2, "QCVCascadeClassifier_detectMultiScale2");
 
 procedure QCVCascadeClassifier_detectMultiScale3(handle:not null QCVCascadeClassifierH;frame:QCVMatH;objects:QCVFacesH;rejectLevels:QCVLabelsH;levelWeights: QCVWeightsH;scaleFactor :qreal :=  1.1;minNeighbors :integer :=  3;flags : integer :=  0;minSize :QCVSizeH := QCVSize_create;maxSize :QCVSizeH := QCVSize_create;outputRejectLevels : boolean :=  false );
 pragma Import(C,QCVCascadeClassifier_detectMultiScale3, "QCVCascadeClassifier_detectMultiScale3");
 
 function  QCVCascadeClassifier_isOldFormatCascade(handle:not null QCVCascadeClassifierH) return boolean;
 pragma Import(C,QCVCascadeClassifier_isOldFormatCascade, "QCVCascadeClassifier_isOldFormatCascade");
 
 function  QCVCascadeClassifier_getOriginalWindowSize(handle:not null QCVCascadeClassifierH) return QCVSizeH;
 pragma Import(C,QCVCascadeClassifier_getOriginalWindowSize, "QCVCascadeClassifier_getOriginalWindowSize");
 
 function  QCVCascadeClassifier_getFeatureType(handle:not null QCVCascadeClassifierH) return integer;
 pragma Import(C,QCVCascadeClassifier_getFeatureType, "QCVCascadeClassifier_getFeatureType");
 
 function  QCVCascadeClassifier_getOldCascade(handle:not null QCVCascadeClassifierH) return void_Star;
 pragma Import(C,QCVCascadeClassifier_getOldCascade, "QCVCascadeClassifier_getOldCascade");
 
 function  QCVCascadeClassifier_convert(oldcascade,newcascade: QStringH) return boolean;
 pragma Import(C,QCVCascadeClassifier_convert, "QCVCascadeClassifier_convert");
 
 function  QCVCascadeClassifier_errorMessage return QStringH;
 pragma Import(C,QCVCascadeClassifier_errorMessage, "QCVCascadeClassifier_errorMessage");
---------------------------------------------------------------------------
 function  QCVCascadeClassifier_create(fileName:QStringH) return QCVCascadeClassifierH;
 procedure QCVCascadeClassifier_detectMultiScale(handle:not null QCVCascadeClassifierH;frame: QCVMatH;objects:QCVFacesH;numDetections:QCVLabelsH;scaleFactor:qreal := 1.1;minNeighbors:integer := 3;flags: integer := 0;minSize :QCVSizeH := QCVSize_create;maxSize :QCVSizeH := QCVSize_create);
 procedure QCVCascadeClassifier_detectMultiScale(handle:not null QCVCascadeClassifierH;frame:QCVMatH;objects:QCVFacesH;rejectLevels:QCVLabelsH;levelWeights: QCVWeightsH;scaleFactor :qreal :=  1.1;minNeighbors :integer :=  3;flags : integer :=  0;minSize :QCVSizeH := QCVSize_create;maxSize :QCVSizeH := QCVSize_create;outputRejectLevels : boolean :=  false );

end;
