--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021,2022                      
--  Copyright (C) 2021,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

package body Qt.QCVCore is

 function  QCVPoint_create(x,y: integer) return QCVPointH is
 begin
   return  QCVPoint_create2(x,y);
 end;

 function  QCVRect_create(x,y,width,height: integer) return QCVRectH is
 begin
   return  QCVRect_create2(x,y,width,height);
 end;

 function  QCVSize_create(width,height: integer) return QCVSizeH is
 begin
   return  QCVSize_create2(width,height);
 end;
 
 function  QCVString_create(str:zstring) return QCVStringH is
 begin
   return  QCVString_create2(str);
 end;

 function  QCVString_create(str:string;n:integer) return QCVStringH is
 begin
   return  QCVString_create3(str,n);
 end;

 function  QCVString_create(first,last:zstring) return QCVStringH is
 begin
   return  QCVString_create4(first,last);
 end;

 function  QCVString_create(str:QCVStringH) return QCVStringH is
 begin
   return  QCVString_create5(str);
 end;

function  QCVScalar_create(v0:qreal;v1: qreal;v2 : qreal :=  0.0;v3 : qreal :=  0.0) return QCVScalarH is
begin
  return  QCVScalar_create2(v0,v1,v2,v3);
end;  

procedure QCVCore_swap(a,b: QCVUMatH) is
begin
  QCVCore_swap2(a,b);
end;

 procedure QCVCore_normalize(src,dst: SparseMatH;alpha: double;normType : integer) is
 begin
  QCVCore_normalize2(src,dst,alpha,normType);
 end;
 procedure QCVCore_minMaxLoc(a:SparseMatH;minVal,maxVal:pdouble;minIdx : pinteger :=  null;maxIdx : pinteger :=  null) is
 begin
  QCVCore_minMaxLoc2(a,minVal,maxVal,minIdx,maxIdx);
 end;
 procedure QCVCore_merge(mv,dst: QCVMatH) is
 begin
  QCVCore_merge2(mv,dst);
 end;
 procedure QCVCore_mixChannels(src,dst: QCVMatH;fromTo:pinteger;npairs: qint64) is
 begin
  QCVCore_mixChannels2(src,dst,fromTo,npairs);
 end;
 function  QCVCore_repeat(src:QCVMatH ;ny,nx: integer) return QCVMatH is
 begin
   return  QCVCore_repeat2(src,ny,nx);
 end;
 procedure QCVCore_hconcat(src1,src2,dst: QCVMatH) is
 begin
  QCVCore_hconcat2(src1,src2,dst);
 end;
 procedure QCVCore_hconcat(src,dst: QCVMatH) is
 begin
  QCVCore_hconcat3(src,dst);
 end;
 procedure QCVCore_vconcat(src1,src2,dst: QCVMatH) is
 begin
  QCVCore_vconcat2(src1,src2,dst);
 end;
 procedure QCVCore_vconcat(src,dst: QCVMatH) is
 begin
  QCVCore_vconcat3(src,dst);
 end;
 procedure QCVCore_min(src1,src2,dst: QCVUMatH) is
 begin
  QCVCore_min2(src1,src2,dst);
 end;

 procedure QCVCore_max(src1,src2,dst: QCVUMatH) is
 begin
  QCVCore_max2(src1,src2,dst);
 end;

 procedure QCVCore_calcCovarMatrix(samples,covar,mean:QCVMatH;flags: integer;ctype : integer :=  CV_64F) is
 begin
  QCVCore_calcCovarMatrix2(samples,covar,mean,flags,ctype);
 end;

 procedure QCVCore_PCACompute(data,mean,eigenvectors,eigenvalues: QCVMatH;maxComponents :integer :=  0) is
 begin
  QCVCore_PCACompute2(data,mean,eigenvectors,eigenvalues,maxComponents);
 end;

 procedure QCVCore_PCACompute(data,mean,eigenvectors: QCVMatH;retainedVariance: double) is
 begin
  QCVCore_PCACompute3(data,mean,eigenvectors,retainedVariance);
 end;

 procedure QCVCore_PCACompute(data,mean,eigenvectors,eigenvalues: QCVMatH;retainedVariance:double) is
 begin
  QCVCore_PCACompute4(data,mean,eigenvectors,eigenvalues,retainedVariance);
 end;
 
end;
