--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021,2022                      
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV; use Qt.OpenCV;
with Qt.QCVMat; use Qt.QCVMat;
with Interfaces.C;use Interfaces.C;
with builtin; use builtin;
package Qt.QCVCore is

 function  QCVPoint_create return QCVPointH;
 pragma Import(C,QCVPoint_create, "QCVPoint_create");
 
 function  QCVPoint_create2(x,y: integer) return QCVPointH;
 pragma Import(C,QCVPoint_create2, "QCVPoint_create2");
 
 function  QCVPoint_x(handle:not null QCVPointH) return integer;
 pragma Import(C,QCVPoint_x, "QCVPoint_x");
 
 function  QCVPoint_y(handle:not null QCVPointH) return integer;
 pragma Import(C,QCVPoint_y, "QCVPoint_y");

 function  QCVPoint2f_create return QCVPoint2fH;
 pragma Import(C,QCVPoint2f_create, "QCVPoint2f_create");
 
 function  QCVPoint2f_create2(x,y: qreal) return QCVPoint2fH;
 pragma Import(C,QCVPoint2f_create2, "QCVPoint2f_create2");
 
 function  QCVPoint2f_x(handle:not null QCVPoint2fH) return qreal;
 pragma Import(C,QCVPoint2f_x, "QCVPoint2f_x");
 
 function  QCVPoint2f_y(handle:not null QCVPoint2fH) return qreal;
 pragma Import(C,QCVPoint2f_y, "QCVPoint2f_y");
 
 function  QCVRect_create return QCVRectH;
 pragma Import(C,QCVRect_create, "QCVRect_create");
 
 function  QCVRect_create2(x,y,width,height: integer) return QCVRectH;
 pragma Import(C,QCVRect_create2, "QCVRect_create2");
 
 function  QCVRect_x(handle:not null QCVRectH) return integer;
 pragma Import(C,QCVRect_x, "QCVRect_x");
 
 function  QCVRect_y(handle:not null QCVRectH) return integer;
 pragma Import(C,QCVRect_y, "QCVRect_y");
 
 function  QCVRect_width(handle:not null QCVRectH) return integer;
 pragma Import(C,QCVRect_width, "QCVRect_width");
 
 function  QCVRect_height(handle:not null QCVRectH) return integer;
 pragma Import(C,QCVRect_height, "QCVRect_height");
 ---------------------------------------------------------------------------------------------
 function  QCVSize_create return QCVSizeH;
 pragma Import(C,QCVSize_create, "QCVSize_create");
 
 function  QCVSize_create2(width,height: integer) return QCVSizeH;
 pragma Import(C,QCVSize_create2, "QCVSize_create2");
 
 function  QCVSize_width(handle:not null QCVSizeH) return integer;
 pragma Import(C,QCVSize_width, "QCVSize_width");
 
 function  QCVSize_height(handle:not null QCVSizeH) return integer;
 pragma Import(C,QCVSize_height, "QCVSize_height");
 
 function  QCVSize_append(handle:not null QCVSizeH;other:QCVSizeH) return QCVSizeH;
 pragma Import(C,QCVSize_append, "QCVSize_append");
 
 procedure QCVSize_setWidth(handle:not null QCVSizeH;width:integer);
 pragma Import(C,QCVSize_setWidth, "QCVSize_setWidth");
 
 procedure QCVSize_setHeight(handle:not null QCVSizeH;height:integer);
 pragma Import(C,QCVSize_setHeight, "QCVSize_setHeight");
 
 function  QCVSize_fromQSize(handle:not null QSizeH) return QCVSizeH;
 pragma Import(C,QCVSize_fromQSize, "QCVSize_fromQSize");
 
 function  QCVSize_toQSize(handle:not null QCVSizeH) return QSizeH;
 pragma Import(C,QCVSize_toQSize, "QCVSize_toQSize");
 
 --------------------------------------------------------------------------------
 function  QCVString_create return QCVStringH;
 pragma Import(C,QCVString_create, "QCVString_create");
 
 function  QCVString_create2(str:zstring) return QCVStringH;
 pragma Import(C,QCVString_create2, "QCVString_create2");
 
 function  QCVString_create3(str:string;n:integer) return QCVStringH;
 pragma Import(C,QCVString_create3, "QCVString_create3");
 
 function  QCVString_create4(first,last:zstring) return QCVStringH;
 pragma Import(C,QCVString_create4, "QCVString_create4");
 
 function  QCVString_create5(str:QCVStringH) return QCVStringH;
 pragma Import(C,QCVString_create5, "QCVString_create5");

 function  QCVString_fromQString(str:QStringH) return QCVStringH;
 pragma Import(C,QCVString_fromQString, "QCVString_fromQString");
 
 function  QCVString_toQString(str:QCVStringH) return QStringH;
 pragma Import(C,QCVString_toQString, "QCVString_toQString");
 ----------------------------------------------------------------------------------------------
 function  QCVScalar_create  return QCVScalarH;
 pragma Import(C,QCVScalar_create, "QCVScalar_create");
 
 function  QCVScalar_create2(v0:qreal;v1: qreal;v2 : qreal :=  0.0;v3 : qreal :=  0.0) return QCVScalarH;
 pragma Import(C,QCVScalar_create2, "QCVScalar_create2");
 
 function  QCVScalar_all(v0:qreal) return QCVScalarH;
 pragma Import(C,QCVScalar_all, "QCVScalar_all");
 
 function  QCVScalar_getVal(handle:not null QCVScalarH;i:integer) return integer;
 pragma Import(C,QCVScalar_getVal, "QCVScalar_getVal");
 
 procedure QCVScalar_setVal(handle:not null QCVScalarH;i:integer;val:qreal);
 pragma Import(C,QCVScalar_setVal, "QCVScalar_setVal");
 
---------------------------------------------------------------------------------------------------------
 
 procedure QCVCore_imshow(name:QStringH;frame:QCVMatH);
 pragma Import(C,QCVCore_imshow, "QCVCore_imshow");
 
 procedure QCVCore_flip(src,dst: QCVMatH;flipCode: integer);
 pragma Import(C,QCVCore_flip, "QCVCore_flip");
 
 procedure QCVCore_destroyAllWindows;
 pragma Import(C,QCVCore_destroyAllWindows,"QCVCore_destroyAllWindows");
 
 function  QCVCore_waitKey(delayMsec : integer := 0) return integer;
 pragma Import(C,QCVCore_waitKey, "QCVCore_waitKey");
 
 type BorderTypes is new integer;
 
  BORDER_CONSTANT    : constant BorderTypes := 0; -- `iiiiii|abcdefgh|iiiiiii`  with some specified `i`
  BORDER_REPLICATE   : constant BorderTypes := 1; -- `aaaaaa|abcdefgh|hhhhhhh`
  BORDER_REFLECT     : constant BorderTypes := 2; -- `fedcba|abcdefgh|hgfedcb`
  BORDER_WRAP        : constant BorderTypes := 3; -- `cdefgh|abcdefgh|abcdefg`
  BORDER_REFLECT_101 : constant BorderTypes := 4; -- `gfedcb|abcdefgh|gfedcba`
  BORDER_TRANSPARENT : constant BorderTypes := 5; -- `uvwxyz|abcdefgh|ijklmno`

  BORDER_REFLECT101  : constant BorderTypes := BORDER_REFLECT_101; -- same as BORDER_REFLECT_101
  BORDER_DEFAULT     : constant BorderTypes := BORDER_REFLECT_101; -- same as BORDER_REFLECT_101
  BORDER_ISOLATED    : constant BorderTypes := 16;-- do not look outside of ROI
  
 procedure QCVCore_copyMakeBorder2(frame:QCVMatH;borderType :BorderTypes := BORDER_REFLECT);
 pragma Import(C,QCVCore_copyMakeBorder2, "QCVCore_copyMakeBorder2");
 
 function  QCVCore_borderInterpolate(p,len: integer;borderType:BorderTypes := BORDER_REFLECT) return integer;
 pragma Import(C,QCVCore_borderInterpolate, "QCVCore_borderInterpolate");
 
 procedure QCVCore_copyMakeBorder(src,dst: QCVMatH;top,bottom,left,right: integer;borderType:BorderTypes := BORDER_REFLECT;scalar:QCVScalarH := QCVScalar_create);
 pragma Import(C,QCVCore_copyMakeBorder, "QCVCore_copyMakeBorder");
 
 procedure QCVCore_rotate(src,dst: QCVMatH;rotateCode: integer);
 pragma Import(C,QCVCore_rotate, "QCVCore_rotate");
 
 type ColorConversionCodes is new integer;

 COLOR_BGR2BGRA     :constant ColorConversionCodes := 0; -- add alpha channel to RGB or BGR image
 COLOR_RGB2RGBA     :constant ColorConversionCodes := COLOR_BGR2BGRA;
 COLOR_BGRA2BGR     :constant ColorConversionCodes := 1; -- remove alpha channel from RGB or BGR image
 COLOR_RGBA2RGB     :constant ColorConversionCodes := COLOR_BGRA2BGR;
 COLOR_BGR2RGBA     :constant ColorConversionCodes := 2; -- convert between RGB and BGR color spaces (with or without alpha channel)
 COLOR_RGB2BGRA     :constant ColorConversionCodes := COLOR_BGR2RGBA;
 COLOR_RGBA2BGR     :constant ColorConversionCodes := 3;
 COLOR_BGRA2RGB     :constant ColorConversionCodes := COLOR_RGBA2BGR;
 COLOR_BGR2RGB      :constant ColorConversionCodes := 4;
 COLOR_RGB2BGR      :constant ColorConversionCodes := COLOR_BGR2RGB;
 COLOR_BGRA2RGBA    :constant ColorConversionCodes := 5;
 COLOR_RGBA2BGRA    :constant ColorConversionCodes := COLOR_BGRA2RGBA;
 COLOR_BGR2GRAY     :constant ColorConversionCodes := 6; -- convert between RGB/BGR and grayscale; @ref color_convert_rgb_gray "color conversions"
 COLOR_RGB2GRAY     :constant ColorConversionCodes := 7;
 COLOR_GRAY2BGR     :constant ColorConversionCodes := 8;
 COLOR_GRAY2RGB     :constant ColorConversionCodes := COLOR_GRAY2BGR;
 COLOR_GRAY2BGRA    :constant ColorConversionCodes := 9;
 COLOR_GRAY2RGBA    :constant ColorConversionCodes := COLOR_GRAY2BGRA;
 COLOR_BGRA2GRAY    :constant ColorConversionCodes := 10;
 COLOR_RGBA2GRAY    :constant ColorConversionCodes := 11;
 COLOR_BGR2BGR565   :constant ColorConversionCodes := 12; -- convert between RGB/BGR and BGR565 (16-bit images)
 COLOR_RGB2BGR565   :constant ColorConversionCodes := 13;
 COLOR_BGR5652BGR   :constant ColorConversionCodes := 14;
 COLOR_BGR5652RGB   :constant ColorConversionCodes := 15;
 COLOR_BGRA2BGR565  :constant ColorConversionCodes := 16;
 COLOR_RGBA2BGR565  :constant ColorConversionCodes := 17;
 COLOR_BGR5652BGRA  :constant ColorConversionCodes := 18;
 COLOR_BGR5652RGBA  :constant ColorConversionCodes := 19;
 COLOR_GRAY2BGR565  :constant ColorConversionCodes := 20; -- convert between grayscale to BGR565 (16-bit images)
 COLOR_BGR5652GRAY  :constant ColorConversionCodes := 21;
 COLOR_BGR2BGR555   :constant ColorConversionCodes := 22;  -- convert between RGB/BGR and BGR555 (16-bit images)
 COLOR_RGB2BGR555   :constant ColorConversionCodes := 23;
 COLOR_BGR5552BGR   :constant ColorConversionCodes := 24;
 COLOR_BGR5552RGB   :constant ColorConversionCodes := 25;
 COLOR_BGRA2BGR555  :constant ColorConversionCodes := 26;
 COLOR_RGBA2BGR555  :constant ColorConversionCodes := 27;
 COLOR_BGR5552BGRA  :constant ColorConversionCodes := 28;
 COLOR_BGR5552RGBA  :constant ColorConversionCodes := 29;
 COLOR_GRAY2BGR555  :constant ColorConversionCodes := 30; -- convert between grayscale and BGR555 (16-bit images)
 COLOR_BGR5552GRAY  :constant ColorConversionCodes := 31;
 COLOR_BGR2XYZ      :constant ColorConversionCodes := 32; -- convert RGB/BGR to CIE XYZ; @ref color_convert_rgb_xyz "color conversions"
 COLOR_RGB2XYZ      :constant ColorConversionCodes := 33;
 COLOR_XYZ2BGR      :constant ColorConversionCodes := 34;
 COLOR_XYZ2RGB      :constant ColorConversionCodes := 35;
 COLOR_BGR2YCrCb    :constant ColorConversionCodes := 36; -- convert RGB/BGR to luma-chroma (aka YCC); @ref color_convert_rgb_ycrcb "color conversions"
 COLOR_RGB2YCrCb    :constant ColorConversionCodes := 37;
 COLOR_YCrCb2BGR    :constant ColorConversionCodes := 38;
 COLOR_YCrCb2RGB    :constant ColorConversionCodes := 39;
 COLOR_BGR2HSV      :constant ColorConversionCodes := 40; -- convert RGB/BGR to HSV (hue saturation value); @ref color_convert_rgb_hsv "color conversions"
 COLOR_RGB2HSV      :constant ColorConversionCodes := 41;
 COLOR_BGR2Lab      :constant ColorConversionCodes := 44; -- convert RGB/BGR to CIE Lab; @ref color_convert_rgb_lab "color conversions"
 COLOR_RGB2Lab      :constant ColorConversionCodes := 45;
 COLOR_BGR2Luv      :constant ColorConversionCodes := 50; -- convert RGB/BGR to CIE Luv; @ref color_convert_rgb_luv "color conversions"
 COLOR_RGB2Luv      :constant ColorConversionCodes := 51;
 COLOR_BGR2HLS      :constant ColorConversionCodes := 52; -- convert RGB/BGR to HLS (hue lightness saturation); @ref color_convert_rgb_hls "color conversions"
 COLOR_RGB2HLS      :constant ColorConversionCodes := 53;
 COLOR_HSV2BGR      :constant ColorConversionCodes := 54; -- backward conversions to RGB/BGR
 COLOR_HSV2RGB      :constant ColorConversionCodes := 55;
 COLOR_Lab2BGR      :constant ColorConversionCodes := 56;
 COLOR_Lab2RGB      :constant ColorConversionCodes := 57;
 COLOR_Luv2BGR      :constant ColorConversionCodes := 58;
 COLOR_Luv2RGB      :constant ColorConversionCodes := 59;
 COLOR_HLS2BGR      :constant ColorConversionCodes := 60;
 COLOR_HLS2RGB      :constant ColorConversionCodes := 61;
 COLOR_BGR2HSV_FULL :constant ColorConversionCodes := 66;
 COLOR_RGB2HSV_FULL :constant ColorConversionCodes := 67;
 COLOR_BGR2HLS_FULL :constant ColorConversionCodes := 68;
 COLOR_RGB2HLS_FULL :constant ColorConversionCodes := 69;
 COLOR_HSV2BGR_FULL :constant ColorConversionCodes := 70;
 COLOR_HSV2RGB_FULL :constant ColorConversionCodes := 71;
 COLOR_HLS2BGR_FULL :constant ColorConversionCodes := 72;
 COLOR_HLS2RGB_FULL :constant ColorConversionCodes := 73;
 COLOR_LBGR2Lab     :constant ColorConversionCodes := 74;
 COLOR_LRGB2Lab     :constant ColorConversionCodes := 75;
 COLOR_LBGR2Luv     :constant ColorConversionCodes := 76;
 COLOR_LRGB2Luv     :constant ColorConversionCodes := 77;
 COLOR_Lab2LBGR     :constant ColorConversionCodes := 78;
 COLOR_Lab2LRGB     :constant ColorConversionCodes := 79;
 COLOR_Luv2LBGR     :constant ColorConversionCodes := 80;
 COLOR_Luv2LRGB     :constant ColorConversionCodes := 81;
 COLOR_BGR2YUV      :constant ColorConversionCodes := 82; -- convert between RGB/BGR and YUV
 COLOR_RGB2YUV      :constant ColorConversionCodes := 83;
 COLOR_YUV2BGR      :constant ColorConversionCodes := 84;
 COLOR_YUV2RGB      :constant ColorConversionCodes := 85;

 --- YUV 4:2:0 family to RGB
 COLOR_YUV2RGB_NV12  :constant ColorConversionCodes := 90;
 COLOR_YUV2BGR_NV12  :constant ColorConversionCodes := 91;
 COLOR_YUV2RGB_NV21  :constant ColorConversionCodes := 92;
 COLOR_YUV2BGR_NV21  :constant ColorConversionCodes := 93;
 COLOR_YUV420sp2RGB  :constant ColorConversionCodes := COLOR_YUV2RGB_NV21;
 COLOR_YUV420sp2BGR  :constant ColorConversionCodes := COLOR_YUV2BGR_NV21;
 COLOR_YUV2RGBA_NV12 :constant ColorConversionCodes := 94;
 COLOR_YUV2BGRA_NV12 :constant ColorConversionCodes := 95;
 COLOR_YUV2RGBA_NV21 :constant ColorConversionCodes := 96;
 COLOR_YUV2BGRA_NV21 :constant ColorConversionCodes := 97;
 COLOR_YUV420sp2RGBA :constant ColorConversionCodes := COLOR_YUV2RGBA_NV21;
 COLOR_YUV420sp2BGRA :constant ColorConversionCodes := COLOR_YUV2BGRA_NV21;
 COLOR_YUV2RGB_YV12  :constant ColorConversionCodes := 98;
 COLOR_YUV2BGR_YV12  :constant ColorConversionCodes := 99;
 COLOR_YUV2RGB_IYUV  :constant ColorConversionCodes := 100;
 COLOR_YUV2BGR_IYUV  :constant ColorConversionCodes := 101;
 COLOR_YUV2RGB_I420  :constant ColorConversionCodes := COLOR_YUV2RGB_IYUV;
 COLOR_YUV2BGR_I420  :constant ColorConversionCodes := COLOR_YUV2BGR_IYUV;
 COLOR_YUV420p2RGB   :constant ColorConversionCodes := COLOR_YUV2RGB_YV12;
 COLOR_YUV420p2BGR   :constant ColorConversionCodes := COLOR_YUV2BGR_YV12;
 COLOR_YUV2RGBA_YV12 :constant ColorConversionCodes := 102;
 COLOR_YUV2BGRA_YV12 :constant ColorConversionCodes := 103;
 COLOR_YUV2RGBA_IYUV :constant ColorConversionCodes := 104;
 COLOR_YUV2BGRA_IYUV :constant ColorConversionCodes := 105;
 COLOR_YUV2RGBA_I420 :constant ColorConversionCodes := COLOR_YUV2RGBA_IYUV;
 COLOR_YUV2BGRA_I420 :constant ColorConversionCodes := COLOR_YUV2BGRA_IYUV;
 COLOR_YUV420p2RGBA  :constant ColorConversionCodes := COLOR_YUV2RGBA_YV12;
 COLOR_YUV420p2BGRA  :constant ColorConversionCodes := COLOR_YUV2BGRA_YV12;
 COLOR_YUV2GRAY_420  :constant ColorConversionCodes := 106;
 COLOR_YUV2GRAY_NV21 :constant ColorConversionCodes := COLOR_YUV2GRAY_420;
 COLOR_YUV2GRAY_NV12 :constant ColorConversionCodes := COLOR_YUV2GRAY_420;
 COLOR_YUV2GRAY_YV12 :constant ColorConversionCodes := COLOR_YUV2GRAY_420;
 COLOR_YUV2GRAY_IYUV :constant ColorConversionCodes := COLOR_YUV2GRAY_420;
 COLOR_YUV2GRAY_I420 :constant ColorConversionCodes := COLOR_YUV2GRAY_420;
 COLOR_YUV420sp2GRAY :constant ColorConversionCodes := COLOR_YUV2GRAY_420;
 COLOR_YUV420p2GRAY  :constant ColorConversionCodes := COLOR_YUV2GRAY_420;

 --  YUV 4:2:2 family to RGB
 COLOR_YUV2RGB_UYVY :constant ColorConversionCodes := 107;
 COLOR_YUV2BGR_UYVY :constant ColorConversionCodes := 108;
 --COLOR_YUV2RGB_VYUY = 109;
 --COLOR_YUV2BGR_VYUY = 110;
 COLOR_YUV2RGB_Y422 :constant ColorConversionCodes := COLOR_YUV2RGB_UYVY;
 COLOR_YUV2BGR_Y422 :constant ColorConversionCodes := COLOR_YUV2BGR_UYVY;
 COLOR_YUV2RGB_UYNV :constant ColorConversionCodes := COLOR_YUV2RGB_UYVY;
 COLOR_YUV2BGR_UYNV :constant ColorConversionCodes := COLOR_YUV2BGR_UYVY;
 COLOR_YUV2RGBA_UYVY :constant ColorConversionCodes := 111;
 COLOR_YUV2BGRA_UYVY :constant ColorConversionCodes := 112;
 --COLOR_YUV2RGBA_VYUY = 113;
 --COLOR_YUV2BGRA_VYUY = 114;
 COLOR_YUV2RGBA_Y422 :constant ColorConversionCodes := COLOR_YUV2RGBA_UYVY;
 COLOR_YUV2BGRA_Y422 :constant ColorConversionCodes := COLOR_YUV2BGRA_UYVY;
 COLOR_YUV2RGBA_UYNV :constant ColorConversionCodes := COLOR_YUV2RGBA_UYVY;
 COLOR_YUV2BGRA_UYNV :constant ColorConversionCodes := COLOR_YUV2BGRA_UYVY;
 COLOR_YUV2RGB_YUY2  :constant ColorConversionCodes := 115;
 COLOR_YUV2BGR_YUY2  :constant ColorConversionCodes := 116;
 COLOR_YUV2RGB_YVYU  :constant ColorConversionCodes := 117;
 COLOR_YUV2BGR_YVYU  :constant ColorConversionCodes := 118;
 COLOR_YUV2RGB_YUYV  :constant ColorConversionCodes := COLOR_YUV2RGB_YUY2;
 COLOR_YUV2BGR_YUYV  :constant ColorConversionCodes := COLOR_YUV2BGR_YUY2;
 COLOR_YUV2RGB_YUNV  :constant ColorConversionCodes := COLOR_YUV2RGB_YUY2;
 COLOR_YUV2BGR_YUNV  :constant ColorConversionCodes := COLOR_YUV2BGR_YUY2;
 COLOR_YUV2RGBA_YUY2 :constant ColorConversionCodes := 119;
 COLOR_YUV2BGRA_YUY2 :constant ColorConversionCodes := 120;
 COLOR_YUV2RGBA_YVYU :constant ColorConversionCodes := 121;
 COLOR_YUV2BGRA_YVYU :constant ColorConversionCodes := 122;
 COLOR_YUV2RGBA_YUYV :constant ColorConversionCodes := COLOR_YUV2RGBA_YUY2;
 COLOR_YUV2BGRA_YUYV :constant ColorConversionCodes := COLOR_YUV2BGRA_YUY2;
 COLOR_YUV2RGBA_YUNV :constant ColorConversionCodes := COLOR_YUV2RGBA_YUY2;
 COLOR_YUV2BGRA_YUNV :constant ColorConversionCodes := COLOR_YUV2BGRA_YUY2;
 COLOR_YUV2GRAY_UYVY :constant ColorConversionCodes := 123;
 COLOR_YUV2GRAY_YUY2 :constant ColorConversionCodes := 124;
 --CV_YUV2GRAY_VYUY    = CV_YUV2GRAY_UYVY;
 COLOR_YUV2GRAY_Y422 :constant ColorConversionCodes := COLOR_YUV2GRAY_UYVY;
 COLOR_YUV2GRAY_UYNV :constant ColorConversionCodes := COLOR_YUV2GRAY_UYVY;
 COLOR_YUV2GRAY_YVYU :constant ColorConversionCodes := COLOR_YUV2GRAY_YUY2;
 COLOR_YUV2GRAY_YUYV :constant ColorConversionCodes := COLOR_YUV2GRAY_YUY2;
 COLOR_YUV2GRAY_YUNV :constant ColorConversionCodes := COLOR_YUV2GRAY_YUY2;

 --  alpha premultiplication
 COLOR_RGBA2mRGBA    :constant ColorConversionCodes := 125;
 COLOR_mRGBA2RGBA    :constant ColorConversionCodes := 126;

 --  RGB to YUV 4:2:0 family
 COLOR_RGB2YUV_I420  :constant ColorConversionCodes := 127;
 COLOR_BGR2YUV_I420  :constant ColorConversionCodes := 128;
 COLOR_RGB2YUV_IYUV  :constant ColorConversionCodes := COLOR_RGB2YUV_I420;
 COLOR_BGR2YUV_IYUV  :constant ColorConversionCodes := COLOR_BGR2YUV_I420;
 COLOR_RGBA2YUV_I420 :constant ColorConversionCodes := 129;
 COLOR_BGRA2YUV_I420 :constant ColorConversionCodes := 130;
 COLOR_RGBA2YUV_IYUV :constant ColorConversionCodes := COLOR_RGBA2YUV_I420;
 COLOR_BGRA2YUV_IYUV :constant ColorConversionCodes := COLOR_BGRA2YUV_I420;
 COLOR_RGB2YUV_YV12  :constant ColorConversionCodes := 131;
 COLOR_BGR2YUV_YV12  :constant ColorConversionCodes := 132;
 COLOR_RGBA2YUV_YV12 :constant ColorConversionCodes := 133;
 COLOR_BGRA2YUV_YV12 :constant ColorConversionCodes := 134;

 --  Demosaicing
 COLOR_BayerBG2BGR   :constant ColorConversionCodes := 46;
 COLOR_BayerGB2BGR   :constant ColorConversionCodes := 47;
 COLOR_BayerRG2BGR   :constant ColorConversionCodes := 48;
 COLOR_BayerGR2BGR   :constant ColorConversionCodes := 49;
 COLOR_BayerBG2RGB   :constant ColorConversionCodes := COLOR_BayerRG2BGR;
 COLOR_BayerGB2RGB   :constant ColorConversionCodes := COLOR_BayerGR2BGR;
 COLOR_BayerRG2RGB   :constant ColorConversionCodes := COLOR_BayerBG2BGR;
 COLOR_BayerGR2RGB   :constant ColorConversionCodes := COLOR_BayerGB2BGR;
 COLOR_BayerBG2GRAY  :constant ColorConversionCodes := 86;
 COLOR_BayerGB2GRAY  :constant ColorConversionCodes := 87;
 COLOR_BayerRG2GRAY  :constant ColorConversionCodes := 88;
 COLOR_BayerGR2GRAY  :constant ColorConversionCodes := 89;

 --  Demosaicing using Variable Number of Gradients
 COLOR_BayerBG2BGR_VNG :constant ColorConversionCodes := 62;
 COLOR_BayerGB2BGR_VNG :constant ColorConversionCodes := 63;
 COLOR_BayerRG2BGR_VNG :constant ColorConversionCodes := 64;
 COLOR_BayerGR2BGR_VNG :constant ColorConversionCodes := 65;
 COLOR_BayerBG2RGB_VNG :constant ColorConversionCodes := COLOR_BayerRG2BGR_VNG;
 COLOR_BayerGB2RGB_VNG :constant ColorConversionCodes := COLOR_BayerGR2BGR_VNG;
 COLOR_BayerRG2RGB_VNG :constant ColorConversionCodes := COLOR_BayerBG2BGR_VNG;
 COLOR_BayerGR2RGB_VNG :constant ColorConversionCodes := COLOR_BayerGB2BGR_VNG;

 --  Edge-Aware Demosaicing
 COLOR_BayerBG2BGR_EA  :constant ColorConversionCodes := 135;
 COLOR_BayerGB2BGR_EA  :constant ColorConversionCodes := 136;
 COLOR_BayerRG2BGR_EA  :constant ColorConversionCodes := 137;
 COLOR_BayerGR2BGR_EA  :constant ColorConversionCodes := 138;
 COLOR_BayerBG2RGB_EA  :constant ColorConversionCodes := COLOR_BayerRG2BGR_EA;
 COLOR_BayerGB2RGB_EA  :constant ColorConversionCodes := COLOR_BayerGR2BGR_EA;
 COLOR_BayerRG2RGB_EA  :constant ColorConversionCodes := COLOR_BayerBG2BGR_EA;
 COLOR_BayerGR2RGB_EA  :constant ColorConversionCodes := COLOR_BayerGB2BGR_EA;

 --  Demosaicing with alpha channel
 COLOR_BayerBG2BGRA    :constant ColorConversionCodes := 139;
 COLOR_BayerGB2BGRA    :constant ColorConversionCodes := 140;
 COLOR_BayerRG2BGRA    :constant ColorConversionCodes := 141;
 COLOR_BayerGR2BGRA    :constant ColorConversionCodes := 142;
 COLOR_BayerBG2RGBA    :constant ColorConversionCodes := COLOR_BayerRG2BGRA;
 COLOR_BayerGB2RGBA    :constant ColorConversionCodes := COLOR_BayerGR2BGRA;
 COLOR_BayerRG2RGBA    :constant ColorConversionCodes := COLOR_BayerBG2BGRA;
 COLOR_BayerGR2RGBA    :constant ColorConversionCodes := COLOR_BayerGB2BGRA;
 COLOR_COLORCVT_MAX    :constant ColorConversionCodes := 143;
 
 procedure QCVCore_cvtColor(src,dst: QCVMatH;code: ColorConversionCodes;dstCn : integer :=  0);
 pragma Import(C,QCVCore_cvtColor, "QCVCore_cvtColor");
 
 type InterpolationFlags is new integer;
 INTER_NEAREST        : constant InterpolationFlags := 0;
 INTER_LINEAR         : constant InterpolationFlags := 1;
 INTER_CUBIC          : constant InterpolationFlags := 2;
 INTER_AREA           : constant InterpolationFlags := 3;
 INTER_LANCZOS4       : constant InterpolationFlags := 4;
 INTER_LINEAR_EXACT   : constant InterpolationFlags := 5;
 INTER_MAX            : constant InterpolationFlags := 7;
 WARP_FILL_OUTLIERS   : constant InterpolationFlags := 8;
 WARP_INVERSE_MAP     : constant InterpolationFlags := 16;

 procedure QCVCore_resize(src,dst: QCVMatH;dsize:QSizeH;fx :qreal := 0.0;fy : qreal := 0.0;interpolation : InterpolationFlags :=  INTER_LINEAR);
 pragma Import(C,QCVCore_resize, "QCVCore_resize");
 
 type WindowFlags is new integer;
 WINDOW_NORMAL       : constant WindowFlags := 0; -- the user can resize the window (no constraint) / also use to switch a fullscreen window to a normal size.
 WINDOW_AUTOSIZE     : constant WindowFlags := 1; -- the user cannot resize the window, the size is constrainted by the image displayed.
 WINDOW_OPENGL       : constant WindowFlags := 16#1000#; -- window with opengl support.
 WINDOW_FULLSCREEN   : constant WindowFlags := 1;          -- change the window to fullscreen.
 WINDOW_FREERATIO    : constant WindowFlags := 16#100#; -- the image expends as much as it can (no ratio constraint).
 WINDOW_KEEPRATIO    : constant WindowFlags := 0; -- the ratio of the image is respected.
 WINDOW_GUI_EXPANDED : constant WindowFlags :=0; -- status bar and tool bar
 WINDOW_GUI_NORMAL   : constant WindowFlags :=16#10#; -- old fashious way
 
 procedure QCVCore_namedWindow(winname: QStringH;flags: WindowFlags := WINDOW_AUTOSIZE);
 pragma Import(C,QCVCore_namedWindow, "QCVCore_namedWindow");
 
 type LineTypes is new integer; 
 FILLED  : constant LineTypes := -1;
 LINE_4  : constant LineTypes :=  4; -- 4-connected lin
 LINE_8  : constant LineTypes :=  8; -- 8-connected lin
 LINE_AA : constant LineTypes := 16; -- antialiased lin

 type HersheyFonts is new integer; 
 FONT_HERSHEY_SIMPLEX        : constant HersheyFonts := 0;  -- normal size sans-serif fon
 FONT_HERSHEY_PLAIN          : constant HersheyFonts := 1;  -- small size sans-serif fon
 FONT_HERSHEY_DUPLEX         : constant HersheyFonts := 2;  -- normal size sans-serif font (more complex than FONT_HERSHEY_SIMPLEX
 FONT_HERSHEY_COMPLEX        : constant HersheyFonts := 3;  -- normal size serif fon
 FONT_HERSHEY_TRIPLEX        : constant HersheyFonts := 4;  -- normal size serif font (more complex than FONT_HERSHEY_COMPLEX
 FONT_HERSHEY_COMPLEX_SMALL  : constant HersheyFonts := 5;  -- smaller version of FONT_HERSHEY_COMPLE
 FONT_HERSHEY_SCRIPT_SIMPLEX : constant HersheyFonts := 6;  -- hand-writing style fon
 FONT_HERSHEY_SCRIPT_COMPLEX : constant HersheyFonts := 7;  -- more complex variant of FONT_HERSHEY_SCRIPT_SIMPLE
 FONT_ITALIC                 : constant HersheyFonts := 16; -- flag for italic fon

 type NormTypes is new integer;
 NORM_INF       : constant NormTypes := 1;
 NORM_L1        : constant NormTypes := 2;
 NORM_L2        : constant NormTypes := 4;
 NORM_L2SQR     : constant NormTypes := 5;
 NORM_HAMMING   : constant NormTypes := 6;
 NORM_HAMMING2  : constant NormTypes := 7;
 NORM_TYPE_MASK : constant NormTypes := 7;
 NORM_RELATIVE  : constant NormTypes := 8;
 NORM_MINMAX    : constant NormTypes := 32;
 
 DECOMP_LU       : constant := 0;
 DECOMP_SVD      : constant := 1;
 DECOMP_CHOLESKY : constant := 3;
 DECOMP_QR       : constant := 4;
 DECOMP_NORMAL   : constant := 16;
 
 procedure QCVCore_putText(frame:QCVMatH;text:QStringH;org: QPointH;fontFace: HersheyFonts;fontScale:qreal;color: QCVScalarH;thickness :integer :=  1;lineType : LineTypes :=  LINE_8;bottomLeftOrigin : boolean :=  false );
 pragma Import(C,QCVCore_putText, "QCVCore_putText");

 procedure QCVCore_absdiff(src1,src2,dst: QCVMatH);
 pragma Import(C,QCVCore_absdiff, "QCVCore_absdiff");
 
 function  QCVCore_countNonZero(src:QCVMatH) return integer;
 pragma Import(C,QCVCore_countNonZero, "QCVCore_countNonZero");
 
 procedure QCVCore_swap(a,b: QCVMatH);
 pragma Import(C,QCVCore_swap, "QCVCore_swap");
 
 procedure QCVCore_swap2(a,b: QCVUMatH);
 pragma Import(C,QCVCore_swap2, "QCVCore_swap2");
 
  procedure QCVCore_add(src1,src2,dst:  QCVMatH;mask : QCVMatH := QCVMat_create;dtype: integer :=  -1);
 pragma Import(C,QCVCore_add, "QCVCore_add");
 
 procedure QCVCore_subtract(src1,src2,dst: QCVMatH;mask: QCVMatH := QCVMat_create;dtype : integer :=  -1);
 pragma Import(C,QCVCore_subtract, "QCVCore_subtract");
 
 procedure QCVCore_multiply(src1,src2,dst: QCVMatH;scale : qreal := 1.0;dtype : integer :=  -1);
 pragma Import(C,QCVCore_multiply, "QCVCore_multiply");
 
 procedure QCVCore_multiply2(src1,src2,dst: QCVMatH;scale: qreal := 1.0;dtype : integer :=  -1);
 pragma Import(C,QCVCore_multiply2, "QCVCore_multiply2");
 
 procedure QCVCore_divide(scale:qreal;src2,dst: QCVMatH;dtype: int := -1);
 pragma Import(C,QCVCore_divide, "QCVCore_divide");
 
 procedure QCVCore_scaleAdd(src1: QCVMatH;alpha: qreal;src2,dst: QCVMatH);
 pragma Import(C,QCVCore_scaleAdd, "QCVCore_scaleAdd");
 
 procedure QCVCore_addWeighted(src1: QCVMatH;alpha: qreal;src2: QCVMatH; beta,gamma: qreal;dst: QCVMatH;dtype : integer :=  -1);
 pragma Import(C,QCVCore_addWeighted, "QCVCore_addWeighted");
 
 procedure QCVCore_convertScaleAbs(src,dst: QCVMatH;alpha :qreal := 1.0; beta : qreal :=  0.0);
 pragma Import(C,QCVCore_convertScaleAbs, "QCVCore_convertScaleAbs");
 
 procedure QCVCore_convertFp16(src,dst:  QCVMatH);
 pragma Import(C,QCVCore_convertFp16, "QCVCore_convertFp16");
 
 procedure QCVCore_LUT(src,lut,dst:  QCVMatH);
 pragma Import(C,QCVCore_LUT, "QCVCore_LUT");
 
 procedure QCVCore_QCVCore_findNonZero(src,idx : QCVMatH);
 pragma Import(C,QCVCore_QCVCore_findNonZero, "QCVCore_QCVCore_findNonZero");
 
 procedure QCVCore_QCVCore_meanStdDev(src,mean,stddev: QCVMatH;mask : QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_QCVCore_meanStdDev, "QCVCore_QCVCore_meanStdDev");
 
 function  QCVCore_norm(src1: QCVMatH;normType : NormTypes := NORM_L2; mask : QCVMatH :=  QCVMat_create) return qreal;
 pragma Import(C,QCVCore_norm, "QCVCore_norm");
 
 function  QCVCore_PSNR(src1,src2: QCVMatH;R: qreal := 255.0) return qreal;
 pragma Import(C,QCVCore_PSNR, "QCVCore_PSNR");
 
 procedure QCVCore_batchDistance(src1,src2,dist: QCVMatH;dtype: integer;nidx: QCVMatH;normType:NormTypes := NORM_L2;K : integer :=  0;mask : QCVMatH :=  QCVMat_create;update : integer :=  0;crosscheck :boolean :=  false);
 pragma Import(C,QCVCore_batchDistance, "QCVCore_batchDistance");
 
 procedure QCVCore_minMaxLoc(src:QCVMatH; minVal:in out qreal;maxVal :in out qreal; minLoc : QCVPointH := null;maxLoc : QCVPointH :=  null;mask :  QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_minMaxLoc, "QCVCore_minMaxLoc");
 
 procedure QCVCore_minMaxIdx(src: QCVMatH;minVal,maxVal:in out qreal ;minIdx,maxIdx : in out integer ;mask : QCVMatH :=  QCVMat_create );
 pragma Import(C,QCVCore_minMaxIdx, "QCVCore_minMaxIdx");
 
 procedure QCVCore_reduce(src,dst: QCVMatH;dim,rtype: integer;dtype : integer :=  -1);
 pragma Import(C,QCVCore_reduce, "QCVCore_reduce");
 
 procedure QCVCore_merge(mv: QCVMatH;count: integer;dst: QCVMatH);
 pragma Import(C,QCVCore_merge, "QCVCore_merge");
 
 procedure QCVCore_split(src,mvbegin:  QCVMatH);
 pragma Import(C,QCVCore_split, "QCVCore_split");
 
 procedure QCVCore_mixChannels(src: QCVMatH;nsrcs: integer;dst: QCVMatH;ndsts: integer;fromTo: in out integer;npairs: integer);
 pragma Import(C,QCVCore_mixChannels, "QCVCore_mixChannels");
 
 procedure QCVCore_extractChannel(src,dst:QCVMatH;coi: integer);
 pragma Import(C,QCVCore_extractChannel, "QCVCore_extractChannel");
 
 procedure QCVCore_repeat(src: QCVMatH;ny,nx: integer;dst:  QCVMatH);
 pragma Import(C,QCVCore_repeat, "QCVCore_repeat");
 
 function  QCVCore_getTickCount return int64;
 pragma Import(C,QCVCore_getTickCount, "QCVCore_getTickCount");
 
 function  QCVCore_getTickFrequency return double;
 pragma Import(C,QCVCore_getTickFrequency, "QCVCore_getTickFrequency");
 
-------------------------------------------------------------
 SORT_EVERY_ROW    : constant := 0; -- each matrix row is sorted independently
 SORT_EVERY_COLUMN : constant := 1; -- each matrix column is sorted independently; this flag and the previous one are mutually exclusive
 SORT_ASCENDING    : constant := 0; -- each matrix row is sorted in the ascendin  order
 SORT_DESCENDING   : constant := 16;-- each matrix row is sorted in the descending order; this flag and the previous one are alse  mutually exclusive.
-------------------------------------------------------------
 function  QCVPoint_create(x,y: integer) return QCVPointH;
 function  QCVRect_create(x,y,width,height: integer) return QCVRectH;
 function  QCVSize_create(width,height: integer) return QCVSizeH; 
 function  QCVScalar_create(v0:qreal;v1: qreal;v2 : qreal :=  0.0;v3 : qreal :=  0.0) return QCVScalarH;
 function  QCVString_create(str:zstring) return QCVStringH;
 function  QCVString_create(str:string;n:integer) return QCVStringH;
 function  QCVString_create(first,last:zstring) return QCVStringH;
 function  QCVString_create(str:QCVStringH) return QCVStringH;
 procedure QCVCore_swap(a,b: QCVUMatH);
-------------------------------------------------------------------------------------------
 procedure QCVCore_error(exc:QCVExceptionH);
 pragma Import(C,QCVCore_error, "QCVCore_error");
 
 function  QCVCore_sum(src:QCVMatH) return QCVScalarH;
 pragma Import(C,QCVCore_sum, "QCVCore_sum");
 
 function  QCVCore_mean(src:QCVMatH;mask : QCVMatH :=  QCVMat_create) return QCVScalarH;
 pragma Import(C,QCVCore_mean, "QCVCore_mean");
 
 procedure QCVCore_normalize(src,dst: QCVMatH;alpha : double := 1.0;beta : double := 0.0;norm_type : normTypes :=  NORM_L2;dtype : integer :=  -1;mask : QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_normalize, "QCVCore_normalize");
 
 procedure QCVCore_normalize2(src,dst: SparseMatH;alpha: double;normType : integer);
 pragma Import(C,QCVCore_normalize2, "QCVCore_normalize2");
 
 procedure QCVCore_reduceArgMin(src,dst: QCVMatH;axis: integer;lastIndex : boolean :=  false);
 pragma Import(C,QCVCore_reduceArgMin, "QCVCore_reduceArgMin");
 
 procedure QCVCore_reduceArgMax(src,dst: QCVMatH;axis: integer;lastIndex : boolean :=  false);
 pragma Import(C,QCVCore_reduceArgMax, "QCVCore_reduceArgMax");
 
 procedure QCVCore_minMaxLoc2(a:SparseMatH;minVal,maxVal:pdouble;minIdx : pinteger :=  null;maxIdx : pinteger :=  null);
 pragma Import(C,QCVCore_minMaxLoc2, "QCVCore_minMaxLoc2");
 
 procedure QCVCore_merge2(mv,dst: QCVMatH);
 pragma Import(C,QCVCore_merge2, "QCVCore_merge2");
 
 procedure QCVCore_mixChannels2(src,dst: QCVMatH;fromTo:pinteger;npairs: qint64);
 pragma Import(C,QCVCore_mixChannels2, "QCVCore_mixChannels2");
 
 procedure QCVCore_insertChannel(src,dst: QCVMatH;coi: integer);
 pragma Import(C,QCVCore_insertChannel, "QCVCore_insertChannel");
 
 function  QCVCore_repeat2(src:QCVMatH ;ny,nx: integer) return QCVMatH;
 pragma Import(C,QCVCore_repeat2, "QCVCore_repeat2");
 
 procedure QCVCore_hconcat(src: QCVMatH;nsrc: qint64;dst: QCVMatH);
 pragma Import(C,QCVCore_hconcat, "QCVCore_hconcat");
 
 procedure QCVCore_hconcat2(src1,src2,dst: QCVMatH);
 pragma Import(C,QCVCore_hconcat2, "QCVCore_hconcat2");
 
 procedure QCVCore_hconcat3(src,dst: QCVMatH);
 pragma Import(C,QCVCore_hconcat3, "QCVCore_hconcat3");
 
 procedure QCVCore_vconcat(src:QCVMatH;nsrc: qint64;dst: QCVMatH);
 pragma Import(C,QCVCore_vconcat, "QCVCore_vconcat");
 
 procedure QCVCore_vconcat2(src1,src2,dst: QCVMatH);
 pragma Import(C,QCVCore_vconcat2, "QCVCore_vconcat2");
 
 procedure QCVCore_vconcat3(src,dst: QCVMatH);
 pragma Import(C,QCVCore_vconcat3, "QCVCore_vconcat3");
 
 procedure QCVCore_bitwise_and(src1,src2,dst: QCVMatH;mask : QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_bitwise_and, "QCVCore_bitwise_and");
 
 procedure QCVCore_bitwise_or(src1,src2,dst: QCVMatH;mask : QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_bitwise_or, "QCVCore_bitwise_or");
 
 procedure QCVCore_bitwise_xor(src1,src2,dst: QCVMatH;mask : QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_bitwise_xor, "QCVCore_bitwise_xor");
 
 procedure QCVCore_bitwise_not(src,dst: QCVMatH;mask : QCVMatH :=  QCVMat_create);
 pragma Import(C,QCVCore_bitwise_not, "QCVCore_bitwise_not");
 
 procedure QCVCore_copyTo(src,dst: QCVMatH;mask: QCVMatH);
 pragma Import(C,QCVCore_copyTo, "QCVCore_copyTo");
 
 procedure QCVCore_inRange(src,lowerb,upperb,dst: QCVMatH);
 pragma Import(C,QCVCore_inRange, "QCVCore_inRange");
 
 procedure QCVCore_compare(src1,src2,dst: QCVMatH;cmpop: integer);
 pragma Import(C,QCVCore_compare, "QCVCore_compare");
 
 procedure QCVCore_min(src1,src2,dst: QCVMatH);
 pragma Import(C,QCVCore_min, "QCVCore_min");
 
 procedure QCVCore_min2(src1,src2,dst: QCVUMatH);
 pragma Import(C,QCVCore_min2, "QCVCore_min2");
 
 procedure QCVCore_max(src1,src2,dst: QCVMatH);
 pragma Import(C,QCVCore_max, "QCVCore_max");
 
 procedure QCVCore_max2(src1,src2,dst: QCVUMatH);
 pragma Import(C,QCVCore_max2, "QCVCore_max2");
 
 procedure QCVCore_sqrt(src,dst: QCVMatH);
 pragma Import(C,QCVCore_sqrt, "QCVCore_sqrt");
 
 procedure QCVCore_pow(src:QCVMatH;power: double;dst: QCVMatH);
 pragma Import(C,QCVCore_pow, "QCVCore_pow");
 
 procedure QCVCore_exp(src,dst: QCVMatH);
 pragma Import(C,QCVCore_exp, "QCVCore_exp");
 
 procedure QCVCore_log(src,dst: QCVMatH);
 pragma Import(C,QCVCore_log, "QCVCore_log");
 
 procedure QCVCore_polarToCart(magnitude,angle,x,y: QCVMatH;angleInDegrees : boolean :=  false);
 pragma Import(C,QCVCore_polarToCart, "QCVCore_polarToCart");
 
 procedure QCVCore_cartToPolar(x,y,magnitude,angle: QCVMatH;angleInDegrees : boolean :=  false);
 pragma Import(C,QCVCore_cartToPolar, "QCVCore_cartToPolar");
 
 procedure QCVCore_phase(x,y,angle: QCVMatH;angleInDegrees : boolean :=  false);
 pragma Import(C,QCVCore_phase, "QCVCore_phase");
 
 procedure QCVCore_magnitude(x,y,magnitude: QCVMatH);
 pragma Import(C,QCVCore_magnitude, "QCVCore_magnitude");
 
 function  QCVCore_checkRange(a:QCVMatH;quiet : boolean :=  true;pos : QCVPointH :=  null;minVal : double :=  -DBL_MAX;maxVal : double :=  DBL_MAX) return boolean;
 pragma Import(C,QCVCore_checkRange, "QCVCore_checkRange");
 
 procedure QCVCore_patchNaNs(a:QCVMatH;val : double := 0.0);
 pragma Import(C,QCVCore_patchNaNs, "QCVCore_patchNaNs");
 
 procedure QCVCore_gemm(src1,src2: QCVMatH;alpha: double;src3:QCVMatH;beta: double;dst: QCVMatH;flags : integer :=  0);
 pragma Import(C,QCVCore_gemm, "QCVCore_gemm");
 
 procedure QCVCore_mulTransposed(src,dst:QCVMatH;aTa: boolean;del_ta :QCVMatH :=  QCVMat_create;scale : double := 1.0;dtype : integer :=  -1 );
 pragma Import(C,QCVCore_mulTransposed, "QCVCore_mulTransposed");
 
 procedure QCVCore_transpose(src,dst: QCVMatH);
 pragma Import(C,QCVCore_transpose, "QCVCore_transpose");
 
 procedure QCVCore_transposeND(src:QCVMatH;order: pinteger;dst: QCVMatH);
 pragma Import(C,QCVCore_transposeND, "QCVCore_transposeND");
 
 procedure QCVCore_transform(src,dst,m : QCVMatH);
 pragma Import(C,QCVCore_transform, "QCVCore_transform");
 
 procedure QCVCore_perspectiveTransform(src,dst,m : QCVMatH);
 pragma Import(C,QCVCore_perspectiveTransform, "QCVCore_perspectiveTransform");
 
 procedure QCVCore_completeSymm(m:QCVMatH;lowerToUpper : boolean :=  false);
 pragma Import(C,QCVCore_completeSymm, "QCVCore_completeSymm");
 
 procedure QCVCore_setIdentity(mtx:QCVMatH;s : QCVScalarH := QCVScalar_all(1.0));
 pragma Import(C,QCVCore_setIdentity, "QCVCore_setIdentity");
 
 function  QCVCore_determinant(mtx:QCVMatH) return double;
 pragma Import(C,QCVCore_determinant, "QCVCore_determinant");
 
 function  QCVCore_trace(mtx:QCVMatH) return QCVScalarH;
 pragma Import(C,QCVCore_trace, "QCVCore_trace");
 
 function  QCVCore_invert(src,dst: QCVMatH;flags : integer :=  DECOMP_LU) return double;
 pragma Import(C,QCVCore_invert, "QCVCore_invert");
 
 function  QCVCore_solve(src1,src2,dst:QCVMatH;flags : integer :=  DECOMP_LU) return boolean;
 pragma Import(C,QCVCore_solve, "QCVCore_solve");
 
 procedure QCVCore_sort(src,dst: QCVMatH;flags: integer);
 pragma Import(C,QCVCore_sort, "QCVCore_sort");
 
 procedure QCVCore_sortIdx(src,dst: QCVMatH;flags: integer);
 pragma Import(C,QCVCore_sortIdx, "QCVCore_sortIdx");
 
 function  QCVCore_solveCubic(coeffs,roots:QCVMatH) return integer;
 pragma Import(C,QCVCore_solveCubic, "QCVCore_solveCubic");
 
 function  QCVCore_eigen(src,eigenvalues,eigenvectors :QCVMatH :=  QCVMat_create) return boolean;
 pragma Import(C,QCVCore_eigen, "QCVCore_eigen");
 
 procedure QCVCore_eigenNonSymmetric(src,eigenvalues,eigenvectors: QCVMatH);
 pragma Import(C,QCVCore_eigenNonSymmetric, "QCVCore_eigenNonSymmetric");
 
 procedure QCVCore_calcCovarMatrix(samples: QCVMatH;nsamples: integer;covar,mean: QCVMatH;flags: integer;ctype : integer :=  CV_64F);
 pragma Import(C,QCVCore_calcCovarMatrix, "QCVCore_calcCovarMatrix");
 
 procedure QCVCore_calcCovarMatrix2(samples,covar,mean:QCVMatH;flags: integer;ctype : integer :=  CV_64F);
 pragma Import(C,QCVCore_calcCovarMatrix2, "QCVCore_calcCovarMatrix2");
 
 procedure QCVCore_PCACompute(data,mean,eigenvectors:QCVMatH;maxComponents : integer :=  0);
 pragma Import(C,QCVCore_PCACompute, "QCVCore_PCACompute");
 
 procedure QCVCore_PCACompute2(data,mean,eigenvectors,eigenvalues: QCVMatH;maxComponents :integer :=  0);
 pragma Import(C,QCVCore_PCACompute2, "QCVCore_PCACompute2");
 
 procedure QCVCore_PCACompute3(data,mean,eigenvectors: QCVMatH;retainedVariance: double);
 pragma Import(C,QCVCore_PCACompute3, "QCVCore_PCACompute3");
 
 procedure QCVCore_PCACompute4(data,mean,eigenvectors,eigenvalues: QCVMatH;retainedVariance:double);
 pragma Import(C,QCVCore_PCACompute4, "QCVCore_PCACompute4");
 
 procedure QCVCore_PCAProject(data,mean,eigenvectors,result: QCVMatH);
 pragma Import(C,QCVCore_PCAProject, "QCVCore_PCAProject");
 
 procedure QCVCore_PCABackProject(data,mean,eigenvectors,result: QCVMatH);
 pragma Import(C,QCVCore_PCABackProject, "QCVCore_PCABackProject");
 
 procedure QCVCore_SVDecomp(src,w,u,vt: QCVMatH;flags : integer :=  0 );
 pragma Import(C,QCVCore_SVDecomp, "QCVCore_SVDecomp");
 
 procedure QCVCore_SVBackSubst(w,u,vt,rhs,dst :QCVMatH);
 pragma Import(C,QCVCore_SVBackSubst, "QCVCore_SVBackSubst");
 
 function  QCVCore_Mahalanobis(v1,v2,icovar:QCVMatH) return double;
 pragma Import(C,QCVCore_Mahalanobis, "QCVCore_Mahalanobis");
 
 procedure QCVCore_dft(src,dst:QCVMatH;flags : integer :=  0;nonzeroRows : integer :=  0);
 pragma Import(C,QCVCore_dft, "QCVCore_dft");
 
 procedure QCVCore_idft(src,dst:QCVMatH;flags : integer :=  0;nonzeroRows : integer :=  0);
 pragma Import(C,QCVCore_idft, "QCVCore_idft");
 
 procedure QCVCore_dct(src,dst:QCVMatH;flags : integer :=  0);
 pragma Import(C,QCVCore_dct, "QCVCore_dct");
 
 procedure QCVCore_idct(src,dst:QCVMatH;flags : integer :=  0);
 pragma Import(C,QCVCore_idct, "QCVCore_idct");
 
 procedure QCVCore_mulSpectrums(a,b,c:QCVMatH;flags:integer;conjB : boolean := false);
 pragma Import(C,QCVCore_mulSpectrums, "QCVCore_mulSpectrums");
 
 function  QCVCore_getOptimalDFTSize(vecsize:integer) return integer;
 pragma Import(C,QCVCore_getOptimalDFTSize, "QCVCore_getOptimalDFTSize");
 
 function  QCVCore_theRNG return QCVRNGH;
 pragma Import(C,QCVCore_theRNG, "QCVCore_theRNG");
 
 procedure QCVCore_setRNGSeed(seed:integer);
 pragma Import(C,QCVCore_setRNGSeed, "QCVCore_setRNGSeed");
 
 procedure QCVCore_randu(dst,low,high:QCVMatH);
 pragma Import(C,QCVCore_randu, "QCVCore_randu");
 
 procedure QCVCore_randn(dst,mean,stddev:QCVMatH);
 pragma Import(C,QCVCore_randn, "QCVCore_randn");
 
 procedure QCVCore_randShuffle(dst:QCVMatH;iterFactor : double :=  1.0;rng : QCVRNGH := null);
 pragma Import(C,QCVCore_randShuffle, "QCVCore_randShuffle");
 
 function  QCVCore_kmeans(data:QCVMatH;K: integer;bestLabels:QCVMatH;criteria: QCVTermCriteriaH;attempts: integer;flags:integer;centers : QCVMatH :=  QCVMat_create) return double;
 pragma Import(C,QCVCore_kmeans, "QCVCore_kmeans");
 
 function  QCVCore_frameIsChanged(frame,prev_frame: not null QCVMatH;minDiff: integer:= 1500) return boolean;
 pragma Import(C,QCVCore_frameIsChanged, "QCVCore_frameIsChanged");
 
 function  QCVCore_frameChanged(frame,prev_frame: not null QCVMatH) return integer;
 pragma Import(C,QCVCore_frameChanged, "QCVCore_frameChanged");
 
 ----------------------------------------------------------------------------------------------------
 procedure QCVCore_normalize(src,dst: SparseMatH;alpha: double;normType : integer);
 procedure QCVCore_minMaxLoc(a:SparseMatH;minVal,maxVal:pdouble;minIdx : pinteger :=  null;maxIdx : pinteger :=  null);
 procedure QCVCore_merge(mv,dst: QCVMatH);
 procedure QCVCore_mixChannels(src,dst: QCVMatH;fromTo:pinteger;npairs: qint64);
 function  QCVCore_repeat(src:QCVMatH ;ny,nx: integer) return QCVMatH;
 procedure QCVCore_hconcat(src1,src2,dst: QCVMatH);
 procedure QCVCore_hconcat(src,dst: QCVMatH);
 procedure QCVCore_vconcat(src1,src2,dst: QCVMatH);
 procedure QCVCore_vconcat(src,dst: QCVMatH);
 procedure QCVCore_min(src1,src2,dst: QCVUMatH);
 procedure QCVCore_max(src1,src2,dst: QCVUMatH);
 procedure QCVCore_calcCovarMatrix(samples,covar,mean:QCVMatH;flags: integer;ctype : integer :=  CV_64F);
 procedure QCVCore_PCACompute(data,mean,eigenvectors,eigenvalues: QCVMatH;maxComponents :integer :=  0);
 procedure QCVCore_PCACompute(data,mean,eigenvectors: QCVMatH;retainedVariance: double);
 procedure QCVCore_PCACompute(data,mean,eigenvectors,eigenvalues: QCVMatH;retainedVariance:double);

 
end;
