--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

package body Qt.QCVDNN is

 function  QCVDNNNet_readNet(framework:QStringH;bufferModel: QByteArrayH;bufferConfig : QByteArrayH := QByteArray_create) return QCVNetH is
 begin
    return QCVDNNNet_readNet2(framework,bufferModel,bufferConfig);
 end;

 function  QCVDNNNet_readNetFromDarknet(bufferCfg:QByteArrayH;bufferModel : QByteArrayH := QByteArray_create) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromDarknet2(bufferCfg,bufferModel);
 end;

 function  QCVDNNNet_readNetFromDarknet(bufferCfg:QStringH;lenCfg: qint64;bufferModel : QStringH := QString_create;lenModel :qint64 :=  0) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromDarknet3(bufferCfg,lenCfg,bufferModel,lenModel);
 end;

 function  QCVDNNNet_readNetFromCaffe(bufferProto:QByteArrayH; bufferModel :QByteArrayH := QByteArray_create) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromCaffe2(bufferProto, bufferModel);
 end;

 function  QCVDNNNet_readNetFromCaffe(bufferProto:QStringH;lenProto: qint64;bufferModel :QStringH := QString_create; lenModel :qint64 :=  0) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromCaffe3(bufferProto,lenProto,bufferModel,lenModel);
 end;

 function  QCVDNNNet_readNetFromTensorflow( bufferModel:QByteArrayH;bufferConfig :QByteArrayH :=  QByteArray_create) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromTensorflow2(bufferModel,bufferConfig);
 end;

 function  QCVDNNNet_readNetFromTensorflow(bufferModel:QStringH;lenModel: qint64;bufferConfig : QStringH := QString_create;lenConfig :qint64 :=  0) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromTensorflow3(bufferModel,lenModel,bufferConfig,lenConfig);
 end;

 function  QCVDNNNet_readNetFromModelOptimizer(bufferModelConfig:QByteArrayH;bufferWeights: QByteArrayH) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromModelOptimizer2(bufferModelConfig,bufferWeights);
 end;

 function  QCVDNNNet_readNetFromModelOptimizer(bufferModelConfigPtr:QStringH;bufferModelConfigSize: qint64;bufferWeightsPtr: QStringH;bufferWeightsSize: qint64) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromModelOptimizer3(bufferModelConfigPtr,bufferModelConfigSize,bufferWeightsPtr,bufferWeightsSize);
 end;

 function  QCVDNNNet_readNetFromONNX(buffer:QStringH;sizeBuffer: qint64) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromONNX2(buffer,sizeBuffer);
 end;

 function  QCVDNNNet_readNetFromONNX(buffer:QByteArrayH) return QCVNetH is
 begin
   return  QCVDNNNet_readNetFromONNX3(buffer);
 end;

 procedure QCVDNNNet_blobFromImage(image:QCVInputArrayH ;blob: QCVOutputArrayH;scalefactor: double := 1.0;size : QCVSizeH :=  QCVSize_create; mean : QCVScalarH := QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F) is
 begin
   QCVDNNNet_blobFromImage2(image,blob,scalefactor,size, mean,swapRB,crop,ddepth);
 end;

 function  QCVDNNNet_blobFromImages(images:QCVInputArrayH; scalefactor: double := 1.0;size : QCVSizeH :=  QCVSize_create;mean: QCVScalarH := QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F) return QCVMatH is
 begin
   return  QCVDNNNet_blobFromImages3(images,scalefactor,size,mean,swapRB,crop,ddepth);
 end;

 procedure QCVDNNNet_blobFromImages(images:QCVInputArrayOfArraysH;blob: QCVOutputArrayH;scalefactor: double := 1.0;size : QCVSizeH := QCVSize_create;mean:QCVScalarH :=  QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F) is
 begin
   QCVDNNNet_blobFromImages4(images,blob,scalefactor,size,mean,swapRB,crop,ddepth);
 end;

end;
