--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV; use Qt.OpenCV;
with Qt.QCVCore; use Qt.QCVCore;
with Qt; use Qt;
with Qt.QString   ; use Qt.QString;
with Qt.QByteArray; use Qt.QByteArray;
package Qt.QCVDNN is

 function  QCVDNNNet_readNet(model:QStringH;config : QStringH :=  s2qs(""); framework : QStringH :=  s2qs("")) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNet, "QCVDNNNet_readNet");
 
 function  QCVDNNNet_readNet2(framework:QStringH;bufferModel: QByteArrayH;bufferConfig : QByteArrayH := QByteArray_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNet2, "QCVDNNNet_readNet2");
 
 function  QCVDNNNet_readNetFromDarknet( cfgFile:QStringH;darknetModel :QStringH := QString_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromDarknet, "QCVDNNNet_readNetFromDarknet");
 
 function  QCVDNNNet_readNetFromDarknet2(bufferCfg:QByteArrayH;bufferModel : QByteArrayH := QByteArray_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromDarknet2, "QCVDNNNet_readNetFromDarknet2");
 
 function  QCVDNNNet_readNetFromDarknet3(bufferCfg:QStringH;lenCfg: qint64;bufferModel : QStringH := QString_create;lenModel :qint64 :=  0) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromDarknet3, "QCVDNNNet_readNetFromDarknet3");
 
 function  QCVDNNNet_readNetFromCaffe( prototxt:QStringH;caffeModel :QStringH := QString_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromCaffe, "QCVDNNNet_readNetFromCaffe");
 
 function  QCVDNNNet_readNetFromCaffe2(bufferProto:QByteArrayH; bufferModel :QByteArrayH := QByteArray_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromCaffe2, "QCVDNNNet_readNetFromCaffe2");
 
 function  QCVDNNNet_readNetFromCaffe3(bufferProto:QStringH;lenProto: qint64;bufferModel :QStringH := QString_create; lenModel : qint64 :=  0) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromCaffe3, "QCVDNNNet_readNetFromCaffe3");
 
 function  QCVDNNNet_readNetFromTensorflow(model:QStringH;config : QStringH := QString_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromTensorflow, "QCVDNNNet_readNetFromTensorflow");
 
 function  QCVDNNNet_readNetFromTensorflow2( bufferModel:QByteArrayH;bufferConfig :QByteArrayH :=  QByteArray_create) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromTensorflow2, "QCVDNNNet_readNetFromTensorflow2");
 
 function  QCVDNNNet_readNetFromTensorflow3(bufferModel:QStringH;lenModel: qint64;bufferConfig : QStringH := QString_create;lenConfig :qint64 :=  0) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromTensorflow3, "QCVDNNNet_readNetFromTensorflow3");
 
 function  QCVDNNNet_readNetFromTorch(model:QStringH;isBinary : boolean :=  true;evaluate : boolean :=  true) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromTorch, "QCVDNNNet_readNetFromTorch");
 
 function  QCVDNNNet_readTorchBlob(fileName:QStringH;isBinary : boolean :=  true) return QCVMatH;
 pragma Import(C,QCVDNNNet_readTorchBlob, "QCVDNNNet_readTorchBlob");
 
 function  QCVDNNNet_readNetFromModelOptimizer(xml:QStringH;bin:QStringH) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromModelOptimizer, "QCVDNNNet_readNetFromModelOptimizer");
 
 function  QCVDNNNet_readNetFromModelOptimizer2(bufferModelConfig:QByteArrayH;bufferWeights: QByteArrayH) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromModelOptimizer2, "QCVDNNNet_readNetFromModelOptimizer2");
 
 function  QCVDNNNet_readNetFromModelOptimizer3(bufferModelConfigPtr:QStringH;bufferModelConfigSize: qint64;bufferWeightsPtr: QStringH;bufferWeightsSize: qint64) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromModelOptimizer3, "QCVDNNNet_readNetFromModelOptimizer3");
 
 function  QCVDNNNet_readNetFromONNX(onnxFile:QStringH) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromONNX, "QCVDNNNet_readNetFromONNX");
 
 function  QCVDNNNet_readNetFromONNX2(buffer:QStringH;sizeBuffer: qint64) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromONNX2, "QCVDNNNet_readNetFromONNX2");
 
 function  QCVDNNNet_readNetFromONNX3(buffer:QByteArrayH) return QCVNetH;
 pragma Import(C,QCVDNNNet_readNetFromONNX3, "QCVDNNNet_readNetFromONNX3");
 
 function  QCVDNNNet_readTensorFromONNX(path:QStringH) return QCVMatH;
 pragma Import(C,QCVDNNNet_readTensorFromONNX, "QCVDNNNet_readTensorFromONNX");
 
 function  QCVDNNNet_blobFromImage(image:QCVInputArrayH;scalefactor: double := 1.0;size : QCVSizeH := QCVSize_create;mean : QCVScalarH :=  QCVScalar_create; swapRB:boolean := false;crop: boolean := false;ddepth:integer := CV_32F) return QCVMatH;
 pragma Import(C,QCVDNNNet_blobFromImage, "QCVDNNNet_blobFromImage");
 
 procedure QCVDNNNet_blobFromImage2(image:QCVInputArrayH ;blob: QCVOutputArrayH;scalefactor: double := 1.0;size : QCVSizeH :=  QCVSize_create; mean : QCVScalarH := QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F);
 pragma Import(C,QCVDNNNet_blobFromImage2, "QCVDNNNet_blobFromImage2");
 
 function  QCVDNNNet_blobFromImages3(images:QCVInputArrayH; scalefactor: double := 1.0;size : QCVSizeH :=  QCVSize_create;mean: QCVScalarH := QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F) return QCVMatH;
 pragma Import(C,QCVDNNNet_blobFromImages3, "QCVDNNNet_blobFromImages3");
 
 procedure QCVDNNNet_blobFromImages4(images:QCVInputArrayOfArraysH;blob: QCVOutputArrayH;scalefactor: double := 1.0;size : QCVSizeH := QCVSize_create;mean:QCVScalarH :=  QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F);
 pragma Import(C,QCVDNNNet_blobFromImages4, "QCVDNNNet_blobFromImages4");
 
 procedure QCVDNNNet_writeTextGraph(model,output:QStringH);
 pragma Import(C,QCVDNNNet_writeTextGraph, "QCVDNNNet_writeTextGraph");
 
 -----------------------------------------------------------------------------------
 function  QCVDNNNet_readNet(framework:QStringH;bufferModel: QByteArrayH;bufferConfig : QByteArrayH := QByteArray_create) return QCVNetH;
 function  QCVDNNNet_readNetFromDarknet(bufferCfg:QByteArrayH;bufferModel : QByteArrayH := QByteArray_create) return QCVNetH;
 function  QCVDNNNet_readNetFromDarknet(bufferCfg:QStringH;lenCfg: qint64;bufferModel : QStringH := QString_create;lenModel :qint64 :=  0) return QCVNetH;
 function  QCVDNNNet_readNetFromCaffe(bufferProto:QByteArrayH; bufferModel :QByteArrayH := QByteArray_create) return QCVNetH;
 function  QCVDNNNet_readNetFromCaffe(bufferProto:QStringH;lenProto: qint64;bufferModel :QStringH := QString_create; lenModel :int64 :=  0) return QCVNetH;
 function  QCVDNNNet_readNetFromTensorflow( bufferModel:QByteArrayH;bufferConfig :QByteArrayH :=  QByteArray_create) return QCVNetH;
 function  QCVDNNNet_readNetFromTensorflow(bufferModel:QStringH;lenModel: qint64;bufferConfig : QStringH := QString_create;lenConfig :qint64 :=  0) return QCVNetH;
 function  QCVDNNNet_readNetFromModelOptimizer(bufferModelConfig:QByteArrayH;bufferWeights: QByteArrayH) return QCVNetH;
 function  QCVDNNNet_readNetFromModelOptimizer(bufferModelConfigPtr:QStringH;bufferModelConfigSize: qint64;bufferWeightsPtr: QStringH;bufferWeightsSize: qint64) return QCVNetH;
 function  QCVDNNNet_readNetFromONNX(buffer:QStringH;sizeBuffer: qint64) return QCVNetH;
 function  QCVDNNNet_readNetFromONNX(buffer:QByteArrayH) return QCVNetH;
 procedure QCVDNNNet_blobFromImage(image:QCVInputArrayH ;blob: QCVOutputArrayH;scalefactor: double := 1.0;size : QCVSizeH :=  QCVSize_create; mean : QCVScalarH := QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F);
 function  QCVDNNNet_blobFromImages(images:QCVInputArrayH; scalefactor: double := 1.0;size : QCVSizeH :=  QCVSize_create;mean: QCVScalarH := QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F) return QCVMatH;
 procedure QCVDNNNet_blobFromImages(images:QCVInputArrayOfArraysH;blob: QCVOutputArrayH;scalefactor: double := 1.0;size : QCVSizeH := QCVSize_create;mean:QCVScalarH :=  QCVScalar_create; swapRB: boolean := false;crop: boolean := false;ddepth: integer := CV_32F);

end;
