--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.QString;   use Qt.QString;
with Qt.OpenCV;    use Qt.OpenCV;
with Qt.QCVCore;   use Qt.QCVCore; 
package Qt.QCVFaceMark is
 
 function  QCVFaceMark_createFacemarkAAM(model: not null QStringH := s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_createFacemarkAAM, "QCVFaceMark_createFacemarkAAM");
 
 function  QCVFaceMark_createFacemarkLBF(model: not null QStringH := s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_createFacemarkLBF, "QCVFaceMark_createFacemarkLBF");
 
 function  QCVFaceMark_createFacemarkKazemi(handle : not null QCVFacemarkH; model: not null QStringH := s2qs("face_landmark_model.dat")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_createFacemarkKazemi, "QCVFaceMark_createFacemarkKazemi");
 
 function  QCVFaceMark_createFacemarkFisher  return  QCVFacemarkH;
 pragma Import(C,QCVFaceMark_createFacemarkFisher, "QCVFaceMark_createFacemarkFisher");
 
 procedure QCVFaceMark_destroy(handle:not null QCVFacemarkH);
 pragma Import(C,QCVFaceMark_destroy, "QCVFaceMark_destroy");

 function  QCVFaceMark_loadModel(handle : not null QCVFacemarkH; model :not null QStringH) return boolean;
 pragma Import(C,QCVFaceMark_loadModel, "QCVFaceMark_loadModel");
 
 function  QCVFaceMark_fit(handle : not null QCVFacemarkH;image:not null QCVMatH;faces:not null QCVFacesH;landmarks:not null QCVLandmarksH) return boolean;
 pragma Import(C,QCVFaceMark_fit, "QCVFaceMark_fit");

 procedure QCVFaceMark_drawLandmarks(frame:not null QCVMatH;landmarks: not null QCVPointsH);
 pragma Import(C,QCVFaceMark_drawLandmarks, "QCVFaceMark_drawLandmarks");
 
 procedure QCVFaceMark_drawFacemarks(frame:not null QCVMatH;landmarks: not null QCVPointsH;color : not null QCVScalarH :=  QCVScalar_create(255.0,0.0,0.0));
 pragma Import(C,QCVFaceMark_drawFacemarks, "QCVFaceMark_drawFacemarks");
--------------------------------------------------------------------

 function  QCVFaceMark_prepareFacemarkAAM(frame:not null QCVMatH;landmarks:not null QCVLandmarksH;faceDetector:not null QCVCascadeClassifierH;model : not null QStringH :=  s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_prepareFacemarkAAM, "QCVFaceMark_prepareFacemarkAAM");

 function  QCVFaceMark_prepareFacemarkLBF(frame:not null QCVMatH;landmarks:not null QCVLandmarksH;faceDetector:not null QCVCascadeClassifierH;model : not null QStringH :=  s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_prepareFacemarkLBF, "QCVFaceMark_prepareFacemarkLBF");

 function  QCVFaceMark_prepareFacemarkKazemi(frame:not null QCVMatH;landmarks:not null QCVLandmarksH;faceDetector:not null QCVCascadeClassifierH;model : not null QStringH :=  s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_prepareFacemarkKazemi, "QCVFaceMark_prepareFacemarkKazemi");

---------------------------------------------------------------------------------------------------------
 function  QCVFaceMark_prepareFacemarkAAM2(image:not null QCVMatH;faces:not null QCVFacesH;landmarks:not null QCVLandmarksH;model :not null QStringH := s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_prepareFacemarkAAM2, "QCVFaceMark_prepareFacemarkAAM2");
 
 function  QCVFaceMark_prepareFacemarkLBF2(image: not null QCVMatH;landmarks: not null QCVLandmarksH;cascadeFile : not null QStringH :=  s2qs("lbpcascade_frontalface.xml"); model : not null QStringH :=  s2qs("lbfmodel.yaml")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_prepareFacemarkLBF2, "QCVFaceMark_prepareFacemarkLBF2");
 
 function  QCVFaceMark_prepareFacemarkKazemi2(image:not null QCVMatH;faces:not null QCVFacesH;landmarks:not null QCVLandmarksH;model :not null QStringH :=  s2qs("face_landmark_model.dat")) return QCVFacemarkH;
 pragma Import(C,QCVFaceMark_prepareFacemarkKazemi2, "QCVFaceMark_prepareFacemarkKazemi2");
 
 --------------------- draw faceNumber = -1 all faces or only one face number  faceNumber
 procedure QCVFaceMark_drawDetection(frame:not null QCVMatH;landmarks: QCVLandmarksH;faceNumber :integer :=  -1;isDrawFacemarks :boolean :=  true;isDrawLandmarks :boolean :=   true);
 pragma Import(C,QCVFaceMark_drawDetection, "QCVFaceMark_drawDetection");
 
 ------------------------- for training --------------------------------------------------------------------------------
 function  QCVFaceMark_prepareCSV(handle: not null QCVFacemarkH;fileName:not null QStringH;images:not null QCVImagesH;labels:not null QCVLabelsH;separator : character :=  ';') return boolean;
 pragma Import(C,QCVFaceMark_prepareCSV, "QCVFaceMark_prepareCSV");
 
 procedure QCVFaceMark_train(handle:not null QCVFacemarkH;images:not null QCVImagesH;labels:not null QCVLabelsH);
 pragma Import(C,QCVFaceMark_train, "QCVFaceMark_train");
 
 function  QCVFaceMark_baseWidth(images:not null QCVImagesH) return integer;
 pragma Import(C,QCVFaceMark_baseWidth, "QCVFaceMark_baseWidth");
 
 function  QCVFaceMark_baseHeight(images:not null QCVImagesH) return integer;
 pragma Import(C,QCVFaceMark_baseHeight, "QCVFaceMark_baseHeight");
 
 function  QCVFaceMark_predict(handle:not null QCVFacemarkH;image:not null QCVMatH) return integer;
 pragma Import(C,QCVFaceMark_predict, "QCVFaceMark_predict");
 
 procedure QCVFaceMark_putPredictionText(frame:not null QCVMatH;rect: not null QCVRectH;text:QStringH;color :QCVScalarH :=  QCVScalar_create(0.0,255.0,0.0));
 pragma Import(C,QCVFaceMark_putPredictionText, "QCVFaceMark_putPredictionText");
 
 ----------------------  for Kazemi model ---------------------------------------------------------------
 
 function  QCVFaceMark_training(handle : not null QCVFacemarkH;landmarks:not null QCVPoints2fH;configfile: not null QStringH;scale:not null QCVSizeH;modelFilename :not null QStringH := s2qs("face_landmarks.dat")) return boolean;
 pragma Import(C,QCVFaceMark_training, "QCVFaceMark_training");
  
 function  QCVFaceMark_getFaces(handle : not null QCVFacemarkH;frame:not null QCVMatH;faces: not null QCVMatH) return  boolean;
 pragma Import(C,QCVFaceMark_getFaces, "QCVFaceMark_getFaces");
 
end;
