--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV; use Qt.OpenCV;
package Qt.QCVFaceRecognizer is

 type QCVFaceRecognizerH is new QObjectH;

 function  QCVFisherFaceRecognizer_create return QCVFaceRecognizerH;
 pragma Import(C,QCVFisherFaceRecognizer_create, "QCVFisherFaceRecognizer_create");
 
 function  QCVEigenFaceRecognizer_create return QCVFaceRecognizerH;
 pragma Import(C,QCVEigenFaceRecognizer_create, "QCVEigenFaceRecognizer_create");
 
 function  QCVLBPHFaceRecognizer_create return QCVFaceRecognizerH;
 pragma Import(C,QCVLBPHFaceRecognizer_create, "QCVLBPHFaceRecognizer_create");
 
 procedure QCVFaceRecognizer_train(handle:not null QCVFaceRecognizerH;images :QCVFacesH;labels: QCVLabelsH);
 pragma Import(C,QCVFaceRecognizer_train, "QCVFaceRecognizer_train");
 
 procedure QCVFaceRecognizer_update(handle:not null QCVFaceRecognizerH;images :QCVFacesH;labels: QCVLabelsH);
 pragma Import(C,QCVFaceRecognizer_update, "QCVFaceRecognizer_update");
 
 procedure QCVFaceRecognizer_write(handle:not null QCVFaceRecognizerH;fileName:QStringH);
 pragma Import(C,QCVFaceRecognizer_write, "QCVFaceRecognizer_write");
 
 procedure QCVFaceRecognizer_read(handle:not null QCVFaceRecognizerH;fileName:QStringH);
 pragma Import(C,QCVFaceRecognizer_read, "QCVFaceRecognizer_read");
 
 procedure QCVFaceRecognizer_setLabelInfo(handle:not null QCVFaceRecognizerH;label:integer;strInfo: QStringH);
 pragma Import(C,QCVFaceRecognizer_setLabelInfo, "QCVFaceRecognizer_setLabelInfo");
 
 function  QCVFaceRecognizer_getLabelInfo(handle:not null QCVFaceRecognizerH;label:integer) return QStringH;
 pragma Import(C,QCVFaceRecognizer_getLabelInfo, "QCVFaceRecognizer_getLabelInfo");
 
 function  QCVFaceRecognizer_getLabelsByString(handle:not null QCVFaceRecognizerH;str:QStringH) return QCVLabelsH;
 pragma Import(C,QCVFaceRecognizer_getLabelsByString, "QCVFaceRecognizer_getLabelsByString");
 

end;
