--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021,2022                      
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.QLabel  ; use Qt.QLabel;
with Qt.QPalette; use Qt.QPalette;
with Qt.QWidget ; use Qt.QWidget;
with Qt.QPixmap ; use Qt.QPixmap;
with Qt.QBrush  ; use Qt.QBrush;
package body Qt.QCVMat is
 
 function  QCVMat_create(rows,cols:integer;typ: integer) return QCVMatH is
 begin
   return  QCVMat_create2(rows,cols,typ);
 end;

 function  QCVMat_create(size:QCVSizeH;typ: integer) return QCVMatH is
 begin
   return  QCVMat_create3(size,typ);
 end;

 function  QCVMat_create(ndims:integer;sizes:pinteger;typ: integer) return QCVMatH is
 begin
   return  QCVMat_create4(ndims,sizes,typ);
 end;

 function  QCVMat_create(m:QCVMatH) return QCVMatH is
 begin
   return  QCVMat_create5(m);
 end;

 function  QCVMat_create(m:QCVMatH;roi: QCVRectH) return QCVMatH is
 begin
   return  QCVMat_create6(m,roi);
 end;

 procedure QCVMat_create(handle:not null QCVMatH;rows,cols: integer;typ: integer) is
 begin
   QCVMat_create7(handle,rows,cols,typ);
 end;

 procedure QCVMat_create(handle:not null QCVMatH;ndims:integer;sizes:pinteger;typ: integer) is
 begin
   QCVMat_create8(handle,ndims,sizes,typ);
 end;
 
 function  QCVMat_zeros(rows,cols: integer;tp: conversion_type) return QCVMatH is
 begin
   return QCVMat_zeros2(rows,cols,tp); 
 end;

 procedure QLabel_setFrame(handle:not null QLabelH;frame: not null QCVMatH;deepCopy :boolean := false) is
 begin
   QLabel_setPixmap(handle,QPixmap_fromImage(QOpenCV_ConvertMatToQImage(frame,deepCopy)));
 end;

 procedure QWidget_setFrame(handle:not null QWidgetH;frame: not null QCVMatH;deepCopy :boolean := false) is
 pix : QPixmapH;
 pal : QPaletteH := QPalette_create;
 begin
   pix := QPixmap_fromImage(QOpenCV_ConvertMatToQImage(frame,deepCopy));
   QPalette_setBrush(pal,QWidget_backgroundRole(handle), QBrush_create(pix));
   QWidget_setPalette(handle,pal);
   QWidget_setAutoFillBackground(handle,true);
 end;
 
end;
