--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021,2023                      
--  Copyright (C) 2012,2023                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV; use Qt.OpenCV;
with Qt; use Qt;
package Qt.QCVMat is

 function  QCVMat_toQImage(handle:not null QCVMatH) return QImageH;
 pragma Import(C,QCVMat_toQImage, "QCVMat_toQImage");
 
 function  QCVMat_toQPixmap(handle:not null QCVMatH) return QPixmapH;
 pragma Import(C,QCVMat_toQPixmap, "QCVMat_toQPixmap");
 
 function  QCVMat_create return QCVMatH;
 pragma Import(C,QCVMat_create, "QCVMat_create");
 
 function  QCVMat_create2(rows,cols:integer;typ: integer) return QCVMatH;
 pragma Import(C,QCVMat_create2, "QCVMat_create2");
 
 function  QCVMat_create3(size:QCVSizeH;typ: integer) return QCVMatH;
 pragma Import(C,QCVMat_create3, "QCVMat_create3");
 
 function  QCVMat_create4(ndims:integer;sizes:pinteger;typ: integer) return QCVMatH;
 pragma Import(C,QCVMat_create4, "QCVMat_create4");
 
 function  QCVMat_create5(m:QCVMatH) return QCVMatH;
 pragma Import(C,QCVMat_create5, "QCVMat_create5");
 
 function  QCVMat_create6(m:QCVMatH;roi: QCVRectH) return QCVMatH;
 pragma Import(C,QCVMat_create6, "QCVMat_create6");
 
 procedure QCVMat_create7(handle:not null QCVMatH;rows,cols: integer;typ: integer);
 pragma Import(C,QCVMat_create7, "QCVMat_create7");
 
 procedure QCVMat_create8(handle:not null QCVMatH;ndims:integer;sizes:pinteger;typ: integer);
 pragma Import(C,QCVMat_create8, "QCVMat_create8");
 
 function  QCVMat_row(handle:not null QCVMatH;y:integer) return QCVMatH;
 pragma Import(C,QCVMat_row, "QCVMat_row");
 
 function  QCVMat_col(handle:not null QCVMatH;x:integer) return QCVMatH;
 pragma Import(C,QCVMat_col, "QCVMat_col");
 
 function  QCVMat_rowRange(handle:not null QCVMatH;startrow,endrow: integer) return QCVMatH;
 pragma Import(C,QCVMat_rowRange, "QCVMat_rowRange");
 
 procedure QCVMat_clone(handle,clone:not null QCVMatH);
 pragma Import(C,QCVMat_clone, "QCVMat_clone");
 
 function  QCVMat_reshape(handle:not null QCVMatH;cn : integer;rows : integer :=  0) return QCVMatH;
 pragma Import(C,QCVMat_reshape, "QCVMat_reshape");
 
 procedure QCVMat_assignTo(handle:not null QCVMatH;m: QCVMatH;typ : integer :=  -1);
 pragma Import(C,QCVMat_assignTo, "QCVMat_assignTo");
 
 procedure QCVMat_addref(handle:not null QCVMatH);
 pragma Import(C,QCVMat_addref, "QCVMat_addref");
 
 procedure QCVMat_release(handle:not null QCVMatH);
 pragma Import(C,QCVMat_release, "QCVMat_release");
 
 procedure QCVMat_deallocate(handle:not null QCVMatH);
 pragma Import(C,QCVMat_deallocate, "QCVMat_deallocate");
 
 procedure QCVMat_reserve(handle:not null QCVMatH;sz:integer);
 pragma Import(C,QCVMat_reserve, "QCVMat_reserve");
 
 procedure QCVMat_reserveBuffer(handle:not null QCVMatH;sz:integer);
 pragma Import(C,QCVMat_reserveBuffer, "QCVMat_reserveBuffer");
 
 procedure QCVMat_resize(handle:not null QCVMatH;sz:integer);
 pragma Import(C,QCVMat_resize, "QCVMat_resize");
 
 procedure QCVMat_copyTo(handle,copy:not null QCVMatH);
 pragma Import(C,QCVMat_copyTo, "QCVMat_copyTo");
 
 function  QCVMat_colRange(handle:not null QCVMatH;startcol,endcol: integer) return QCVMatH;
 pragma Import(C,QCVMat_colRange, "QCVMat_colRange");
 
 function  QCVMat_diag(handle:not null QCVMatH; d:integer := 0) return QCVMatH;
 pragma Import(C,QCVMat_diag, "QCVMat_diag");
 
 procedure QCVMat_convertTo(handle:not null QCVMatH;m: QCVOutputArrayH;rtype: integer;alpha: qreal := 1.0; beta: qreal := 0.0 );
 pragma Import(C,QCVMat_convertTo, "QCVMat_convertTo");
 
 function  QCVMat_dot(handle:not null QCVMatH;m:QCVInputArrayH) return double;
 pragma Import(C,QCVMat_dot, "QCVMat_dot");
 
 function  QCVMat_rows(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_rows, "QCVMat_rows");
 
 function  QCVMat_cols(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_cols, "QCVMat_cols");
 
 function  QCVMat_step(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_step, "QCVMat_step");
 
 function  QCVMat_isContinuous(handle:not null QCVMatH) return boolean;
 pragma Import(C,QCVMat_isContinuous, "QCVMat_isContinuous");
 
 function  QCVMat_isSubmatrix(handle:not null QCVMatH) return boolean;
 pragma Import(C,QCVMat_isSubmatrix, "QCVMat_isSubmatrix");
 
 function  QCVMat_elemSize(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_elemSize, "QCVMat_elemSize");
 
 function  QCVMat_type(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_type, "QCVMat_type");
 
 function  QCVMat_depth(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_depth, "QCVMat_depth");
 
 function  QCVMat_channels(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_channels, "QCVMat_channels");
 
 function  QCVMat_empty(handle:not null QCVMatH) return boolean;
 pragma Import(C,QCVMat_empty, "QCVMat_empty");
 
 function  QCVMat_total(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_total, "QCVMat_total");
 
 function  QCVMat_size(handle:not null QCVMatH) return QCVSizeH;
 pragma Import(C,QCVMat_size, "QCVMat_size");
 
 function  QCVMat_deserializeMat(matData :QByteArrayH;mode: ImreadModes := IMREAD_GRAYSCALE) return  QCVMatH;
 pragma Import(C,QCVMat_deserializeMat, "QCVMat_deserializeMat");
 
 function  QCVMat_zeros(size:QCVSizeH;tp: conversion_type) return QCVMatH;
 pragma Import(C,QCVMat_zeros, "QCVMat_zeros");
 
 function  QCVMat_zeros2(rows,cols: integer;tp: conversion_type) return QCVMatH;
 pragma Import(C,QCVMat_zeros2, "QCVMat_zeros2");
 
 procedure QCVMat_rect(handle:not null QCVMatH;rect:not null QCVRectH);
 pragma Import(C,QCVMat_rect, "QCVMat_rect");
 
 procedure QCVMat_crop(handle:not null QCVMatH;rect:not null QCVRectH;croppedImage:not null QCVMatH);
 pragma Import(C,QCVMat_crop, "QCVMat_crop");

 function  QCVMat_data(handle:not null QCVMatH) return QObjectH;
 pragma Import(C,QCVMat_data, "QCVMat_data");
 
 procedure QCVMat_changePixelAt(handle: not null QCVMatH;heightPos,widthPos: integer;pixel:Unsigned_Char);
 pragma Import(C,QCVMat_changePixelAt, "QCVMat_changePixelAt");
 
 function  QCVMat_width(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_width, "QCVMat_width");
 
 function  QCVMat_height(handle:not null QCVMatH) return integer;
 pragma Import(C,QCVMat_height, "QCVMat_height");
 
 ------------------------------------------------------------------------------------------------------------
 function  QCVMat_create(rows,cols:integer;typ: integer) return QCVMatH;
 function  QCVMat_create(size:QCVSizeH;typ: integer) return QCVMatH;
 function  QCVMat_create(ndims:integer;sizes:pinteger;typ: integer) return QCVMatH;
 function  QCVMat_create(m:QCVMatH) return QCVMatH;
 function  QCVMat_create(m:QCVMatH;roi: QCVRectH) return QCVMatH;
 procedure QCVMat_create(handle:not null QCVMatH;rows,cols: integer;typ: integer);
 procedure QCVMat_create(handle:not null QCVMatH;ndims:integer;sizes:pinteger;typ: integer);
 function  QCVMat_zeros(rows,cols: integer;tp: conversion_type) return QCVMatH;
 procedure QLabel_setFrame(handle:not null QLabelH;frame: not null QCVMatH;deepCopy :boolean := false);
 procedure QWidget_setFrame(handle:not null QWidgetH;frame: not null QCVMatH;deepCopy :boolean := false);
  
end;
