--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;

package Qt.QCVMatList is

 function  QCVMatList_create return QCVMatListH;
 pragma Import(C,QCVMatList_create, "QCVMatList_create");
 
 procedure QCVMatList_destroy(handle:not null QCVMatListH);
 pragma Import(C,QCVMatList_destroy, "QCVMatList_destroy");
 
 function  QCVMatList_create2(list:QCVMatListH) return QCVMatListH;
 pragma Import(C,QCVMatList_create2, "QCVMatList_create2");
 
 function  QCVMatList_size(handle:not null QCVMatListH) return integer;
 pragma Import(C,QCVMatList_size, "QCVMatList_size");
 
 procedure QCVMatList_clear(handle:not null QCVMatListH);
 pragma Import(C,QCVMatList_clear, "QCVMatList_clear");
 
 function  QCVMatList_isEmpty(handle:not null QCVMatListH) return boolean;
 pragma Import(C,QCVMatList_isEmpty, "QCVMatList_isEmpty");
 
 procedure QCVMatList_append(handle:not null QCVMatListH;o: QCVMatH);
 pragma Import(C,QCVMatList_append, "QCVMatList_append");
 
 procedure QCVMatList_append2(handle:not null QCVMatListH;l: QCVMatListH);
 pragma Import(C,QCVMatList_append2, "QCVMatList_append2");
 
 procedure QCVMatList_prepend(handle:not null QCVMatListH;o: QCVMatH);
 pragma Import(C,QCVMatList_prepend, "QCVMatList_prepend");
 
 procedure QCVMatList_insert(handle:not null QCVMatListH;i: integer;o: QCVMatH);
 pragma Import(C,QCVMatList_insert, "QCVMatList_insert");
 
 procedure QCVMatList_move(handle:not null QCVMatListH;from: integer;to: integer);
 pragma Import(C,QCVMatList_move, "QCVMatList_move");
 
 procedure QCVMatList_swap(handle:not null QCVMatListH;from: integer;to: integer);
 pragma Import(C,QCVMatList_swap, "QCVMatList_swap");
 
 function  QCVMatList_at(handle:not null QCVMatListH;i: integer) return QCVMatH;
 pragma Import(C,QCVMatList_at, "QCVMatList_at");
 
 procedure QCVMatList_detach(handle:not null QCVMatListH);
 pragma Import(C,QCVMatList_detach, "QCVMatList_detach");
 
 procedure QCVMatList_reserve(handle:not null QCVMatListH;size:integer);
 pragma Import(C,QCVMatList_reserve, "QCVMatList_reserve");
 
 procedure QCVMatList_removeAt(handle:not null QCVMatListH;i:integer);
 pragma Import(C,QCVMatList_removeAt, "QCVMatList_removeAt");
 
 procedure QCVMatList_replace(handle:not null QCVMatListH;i:integer;o: QCVMatH);
 pragma Import(C,QCVMatList_replace, "QCVMatList_replace");
 
 function  QCVMatList_takeAt(handle:not null QCVMatListH;i:integer) return QCVMatH;
 pragma Import(C,QCVMatList_takeAt, "QCVMatList_takeAt");
 
 function  QCVMatList_takeFirst(handle:not null QCVMatListH) return QCVMatH;
 pragma Import(C,QCVMatList_takeFirst, "QCVMatList_takeFirst");
 
 function  QCVMatList_takeLast(handle:not null QCVMatListH) return QCVMatH;
 pragma Import(C,QCVMatList_takeLast, "QCVMatList_takeLast");
 
 function  QCVMatList_count(handle:not null QCVMatListH) return integer;
 pragma Import(C,QCVMatList_count, "QCVMatList_count");
 
end;
