--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;
with Qt.QString; use Qt.QString;

package Qt.QCVNCNN is

 function  QNCNNYOLOV7_detect(image:not null QCVMatH;model_param :QStringH := s2qs("models/yolov7-tiny.param"); model_bin :QStringH :=  s2qs("models/yolov7-tiny.bin")) return integer;
 pragma Import(C,QNCNNYOLOV7_detect, "QNCNNYOLOV7_detect");
 
 function  QNCNNYOLOV7_drawObjects(image:not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLOV7_drawObjects, "QNCNNYOLOV7_drawObjects");
 
 function  QNCNN_matAt(imgIn:not null QCVMatH;index:integer) return QCVMatH;
 pragma Import(C,QNCNN_matAt, "QNCNN_matAt");
 
 function  QNCNN_nameAt(index:integer) return QStringH;
 pragma Import(C,QNCNN_nameAt, "QNCNN_nameAt");
 
 function  QNCNN_probeAt(index:integer) return float;
 pragma Import(C,QNCNN_probeAt, "QNCNN_probeAt");
 
 function  QNCNNYOLOX_detect(image:not null QCVMatH;model_param :QStringH := s2qs("models/yolox.param"); model_bin :QStringH :=  s2qs("models/yolox.bin")) return integer;
 pragma Import(C,QNCNNYOLOX_detect, "QNCNNYOLOX_detect");
 
 function  QNCNNYOLOX_drawObjects(image:not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLOX_drawObjects, "QNCNNYOLOX_drawObjects");
 
 function  QNCNNYOLOV5_detect(image:not null QCVMatH;model_param :QStringH := s2qs("models/yolov5s_6.2.param"); model_bin :QStringH :=  s2qs("models/yolov5s_6.2.bin")) return integer;
 pragma Import(C,QNCNNYOLOV5_detect, "QNCNNYOLOV5_detect");
 
 function  QNCNNYOLOV5_drawObjects(image:not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLOV5_drawObjects, "QNCNNYOLOV5_drawObjects");
 
 function  QNCNNYOLOV5PNNX_detect(image:not null QCVMatH;model_param :QStringH := s2qs("models/yolov5s.ncnn.param"); model_bin :QStringH :=  s2qs("models/yolov5s.ncnn.bin")) return integer;
 pragma Import(C,QNCNNYOLOV5PNNX_detect, "QNCNNYOLOV5PNNX_detect");
 
 function  QNCNNYOLOV5PNNX_drawObjects(image:not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLOV5PNNX_drawObjects, "QNCNNYOLOV5PNNX_drawObjects");

 function  QNCNNYOLOV4_init(target_size: in out integer;yolov4_param : QStringH := s2qs("models/yolov4-tiny-opt.param"); yolov4_model :QStringH := s2qs("models/yolov4-tiny-opt.bin")) return QCVNetH;
 pragma Import(C,QNCNNYOLOV4_init, "QNCNNYOLOV4_init");
 
 function  QNCNNYOLOV4_detect(bgr:not null QCVMatH;target_size: integer;yolov4: not null QCVNetH) return integer;
 pragma Import(C,QNCNNYOLOV4_detect, "QNCNNYOLOV4_detect");
 
 function  QNCNNYOLOV4_drawObjects(bgr: not null QCVMatH;is_streaming: integer) return QCVMatH;
 pragma Import(C,QNCNNYOLOV4_drawObjects, "QNCNNYOLOV4_drawObjects");
 
 function  QNCNNYOLOV3_detect(imageIn:not null QCVMatH;model_param :QStringH :=  s2qs("models/mobilenetv2_yolov3.param"); model_bin : QStringH := s2qs("models/mobilenetv2_yolov3.bin")) return integer;
 pragma Import(C,QNCNNYOLOV3_detect, "QNCNNYOLOV3_detect");
 
 function  QNCNNYOLOV3_drawObjects(imageIn : not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLOV3_drawObjects, "QNCNNYOLOV3_drawObjects");
 
 function  QNCNNYOLOV2_detect(imageIn:not null QCVMatH;model_param :QStringH :=  s2qs("models/mobilenet_yolo.param"); model_bin : QStringH := s2qs("models/mobilenet_yolo.bin")) return integer;
 pragma Import(C,QNCNNYOLOV2_detect, "QNCNNYOLOV2_detect");
 
 function  QNCNNYOLOV2_drawObjects(imageIn : not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLOV2_drawObjects, "QNCNNYOLOV2_drawObjects");
 
 function  QNCNNYOLACT_detect(image:not null QCVMatH;model_param :QStringH := s2qs("models/yolact.param"); model_bin :QStringH :=  s2qs("models/yolact.bin")) return integer;
 pragma Import(C,QNCNNYOLACT_detect, "QNCNNYOLACT_detect");
 
 function  QNCNNYOLACT_drawObjects(image:not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNYOLACT_drawObjects, "QNCNNYOLACT_drawObjects");
 
 function  QNCNNSqueezenet_detect(image:not null QCVMatH;model_param :QStringH := s2qs("models/squeezenet_ssd_voc.param"); model_bin :QStringH :=  s2qs("models/squeezenet_ssd_voc.bin")) return integer;
 pragma Import(C,QNCNNSqueezenet_detect, "QNCNNSqueezenet_detect");
 
 function  QNCNNSqueezenet_drawObjects(image:not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNSqueezenet_drawObjects, "QNCNNSqueezenet_drawObjects");

 function  QNCNNPose_detect(imageIn:not null QCVMatH;model_param :QStringH := s2qs("models/pose.param"); model_bin : QStringH :=  s2qs("models/pose.bin")) return integer;
 pragma Import(C,QNCNNPose_detect, "QNCNNPose_detect");
 
 function  QNCNNPose_drawObjects(imageIn: not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNPose_drawObjects, "QNCNNPose_drawObjects");

 function  QNCNNScrfd_detect(imageIn: not null QCVMatH;model_param :QStringH := s2qs("models/scrfd_500m-opt2.param"); model_bin : QStringH := s2qs("models/scrfd_500m-opt2.bin")) return integer;
 pragma Import(C,QNCNNScrfd_detect, "QNCNNScrfd_detect");
 
 function  QNCNNScrfd_drawFaceobjects(imageIn: not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNScrfd_drawFaceobjects, "QNCNNScrfd_drawFaceobjects");
 
 function  QNCNNNanodet_detect(imageIn : not null QCVMatH;model_param :QStringH :=  s2qs("models/nanodet_m.param"); model_bin : QStringH :=  s2qs("models/nanodet_m.bin")) return integer;
 pragma Import(C,QNCNNNanodet_detect, "QNCNNNanodet_detect");
 
 function  QNCNNNanodet_drawObjects(imageIn: not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNNanodet_drawObjects, "QNCNNNanodet_drawObjects");

 function  QNCNNFASTERCNN_detect(imageIn: not null QCVMatH;model_param :QStringH := s2qs("models/ZF_faster_rcnn_final.param"); model_bin : QStringH := s2qs("models/ZF_faster_rcnn_final.bin")) return integer;
 pragma Import(C,QNCNNFASTERCNN_detect, "QNCNNFASTERCNN_detect");
 
 function  QNCNNFASTERCNN_drawObjects(imageIn: not null QCVMatH) return QCVMatH;
 pragma Import(C,QNCNNFASTERCNN_drawObjects, "QNCNNFASTERCNN_drawObjects");
 
end;
