--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;

package Qt.QCVRectList is

 function  QCVRectList_create return QCVRectListH;
 pragma Import(C,QCVRectList_create, "QCVRectList_create");
 
 procedure QCVRectList_destroy(handle:not null QCVRectListH);
 pragma Import(C,QCVRectList_destroy, "QCVRectList_destroy");
 
 function  QCVRectList_create2(list:QCVRectListH) return QCVRectListH;
 pragma Import(C,QCVRectList_create2, "QCVRectList_create2");
 
 function  QCVRectList_size(handle:not null QCVRectListH) return integer;
 pragma Import(C,QCVRectList_size, "QCVRectList_size");
 
 procedure QCVRectList_clear(handle:not null QCVRectListH);
 pragma Import(C,QCVRectList_clear, "QCVRectList_clear");
 
 function  QCVRectList_isEmpty(handle:not null QCVRectListH) return boolean;
 pragma Import(C,QCVRectList_isEmpty, "QCVRectList_isEmpty");
 
 procedure QCVRectList_append(handle:not null QCVRectListH;o: QCVRectH);
 pragma Import(C,QCVRectList_append, "QCVRectList_append");
 
 procedure QCVRectList_append2(handle:not null QCVRectListH;l: QCVRectListH);
 pragma Import(C,QCVRectList_append2, "QCVRectList_append2");
 
 procedure QCVRectList_prepend(handle:not null QCVRectListH;o: QCVRectH);
 pragma Import(C,QCVRectList_prepend, "QCVRectList_prepend");
 
 procedure QCVRectList_insert(handle:not null QCVRectListH;i: integer;o: QCVRectH);
 pragma Import(C,QCVRectList_insert, "QCVRectList_insert");
 
 procedure QCVRectList_move(handle:not null QCVRectListH;from: integer;to: integer);
 pragma Import(C,QCVRectList_move, "QCVRectList_move");
 
 procedure QCVRectList_swap(handle:not null QCVRectListH;from: integer;to: integer);
 pragma Import(C,QCVRectList_swap, "QCVRectList_swap");
 
 function  QCVRectList_at(handle:not null QCVRectListH;i: integer) return QCVRectH;
 pragma Import(C,QCVRectList_at, "QCVRectList_at");
 
 procedure QCVRectList_detach(handle:not null QCVRectListH);
 pragma Import(C,QCVRectList_detach, "QCVRectList_detach");
 
 procedure QCVRectList_reserve(handle:not null QCVRectListH;size:integer);
 pragma Import(C,QCVRectList_reserve, "QCVRectList_reserve");
 
 procedure QCVRectList_removeAt(handle:not null QCVRectListH;i:integer);
 pragma Import(C,QCVRectList_removeAt, "QCVRectList_removeAt");
 
 procedure QCVRectList_replace(handle:not null QCVRectListH;i:integer;o: QCVRectH);
 pragma Import(C,QCVRectList_replace, "QCVRectList_replace");
 
 function  QCVRectList_takeAt(handle:not null QCVRectListH;i:integer) return QCVRectH;
 pragma Import(C,QCVRectList_takeAt, "QCVRectList_takeAt");
 
 function  QCVRectList_takeFirst(handle:not null QCVRectListH) return QCVRectH;
 pragma Import(C,QCVRectList_takeFirst, "QCVRectList_takeFirst");
 
 function  QCVRectList_takeLast(handle:not null QCVRectListH) return QCVRectH;
 pragma Import(C,QCVRectList_takeLast, "QCVRectList_takeLast");
 
 function  QCVRectList_count(handle:not null QCVRectListH) return integer;
 pragma Import(C,QCVRectList_count, "QCVRectList_count");
 
end;
