--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;
with Qt.QString; use Qt.QString;

package Qt.QCVSeet is

 function  QCVSeet_detectFaces(img : not null QCVMatH;model:not null QStringH;result_faces:not null QCVMatListH) return QCVMatH;
 pragma Import(C,QCVSeet_detectFaces, "QCVSeet_detectFaces");
 
 function  QCVSeet_facesCompare(gallery_img_color,probe_img_color:not null QCVMatH;frontal_model:QStringH := s2qs("model/seeta_fd_frontal_v1.0.bin");fa_model:QStringH := s2qs("model/seeta_fa_v1.1.bin");fr_model:QStringH := s2qs("model/seeta_fr_v1.0.bin")) return float ;
 pragma Import(C,QCVSeet_facesCompare, "QCVSeet_facesCompare");
 
 function  QCVSeet_facesBestCandidate(gallery_img_color:not null QCVMatH ;probe_img_colors:QCVMatListH;frontal_model :QStringH:= s2qs("model/seeta_fd_frontal_v1.0.bin");fa_model:QStringH := s2qs("model/seeta_fa_v1.1.bin"); fr_model:QStringH := s2qs("model/seeta_fr_v1.0.bin");debug: boolean := false) return integer;
 pragma Import(C,QCVSeet_facesBestCandidate, "QCVSeet_facesBestCandidate");
 
 function  QCVSeet_facesComparison return QFloatListH;
 pragma Import(C,QCVSeet_facesComparison, "QCVSeet_facesComparison");
 
end;
