--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

package body Qt.QCVVideoCapture is

 function  QVideoCapture_create(fileName: QCVStringH;apiPreference : VideoCaptureAPIs := CAP_ANY) return  QCVVideoCaptureH is
 begin
   return  QVideoCapture_create2(fileName,apiPreference);
 end;

 function  QVideoCapture_create(index:integer;apiPreference : VideoCaptureAPIs := CAP_ANY) return  QCVVideoCaptureH is
 begin
   return  QVideoCapture_create3(index,apiPreference);
 end;

 function  QVideoCapture_open(handle:not null  QCVVideoCaptureH;index:integer;apiPreference : VideoCaptureAPIs := CAP_ANY) return  boolean is
 begin
   return  QVideoCapture_open2(handle,index,apiPreference);
 end;

 function  QVideoWriter_create(fileName:not null QStringH ;fourcc: integer;fps: qt.double;frameSize:QCVSizeH;isColor : boolean :=  true) return QCVVideoWriterH is
 begin
   return  QVideoWriter_create2(fileName,fourcc,fps,frameSize,isColor);
 end;

 function  QVideoWriter_create(fileName:not null QStringH ;apiPreference: integer;fourcc: integer;fps: qt.double;frameSize:QCVSizeH;isColor : boolean :=  true) return QCVVideoWriterH is
 begin
   return  QVideoWriter_create3(fileName,apiPreference,fourcc,fps,frameSize,isColor);
 end;

 function  QVideoWriter_create(fileName:not null QCVStringH ;fourcc: integer;fps: qt.double;frameSize:QCVSizeH;isColor : boolean :=  true) return QCVVideoWriterH is
 begin
    return QVideoWriter_create4(fileName,fourcc,fps,frameSize,isColor);
 end;

 function  QVideoWriter_create(fileName:not null QCVStringH ;apiPreference: integer;fourcc: integer;fps: qt.double;frameSize:QCVSizeH;isColor : boolean :=  true) return QCVVideoWriterH is
 begin
   return QVideoWriter_create5(fileName,apiPreference,fourcc,fps,frameSize,isColor);
 end;

 function  QVideoWriter_open(handle:not null  QCVVideoWriterH;fileName: QStringH;apiPreference: integer;fourcc: integer;fps: qreal;frameSize: QCVSizeH;isColor :  boolean :=  true) return  boolean is
 begin
   return  QVideoWriter_open2(handle,fileName,apiPreference,fourcc,fps,frameSize,isColor);
 end;

 function  QVideoWriter_createFromFrame(fileName:QStringH;fourcc: integer;fps: double;frameWidth,frameHeight:integer;isColor : boolean :=  true) return QCVVideoWriterH is
 begin
   return  QVideoWriter_createFromFrame2(fileName,fourcc,fps,frameWidth,frameHeight,isColor);
 end;

 function  QVideoWriter_openFromFrame(handle:not null QCVVideoWriterH;fileName:QStringH;apiPreference: integer;fourcc: integer;fps: double;frameWidth,frameHeight:integer;isColor : boolean :=  true) return boolean is
 begin
   return  QVideoWriter_openFromFrame2(handle,fileName,apiPreference,fourcc,fps,frameWidth,frameHeight,isColor);
 end;

end;
