--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV; use Qt.OpenCV;
package Qt.QCVVideoReciever    is
 
 function  QCVVideoReciever_create(parent: QObjectH := null) return QCVVideoRecieverH;
 pragma Import(C,QCVVideoReciever_create, "QCVVideoReciever_create");
 
 procedure QCVVideoReciever_destroy(handle:not null QCVVideoRecieverH);
 pragma Import(C,QCVVideoReciever_destroy, "QCVVideoReciever_destroy");
 
 procedure QCVVideoReciever_listen(handle:not null QCVVideoRecieverH;port:quint16;interval :double :=  5.0 );
 pragma Import(C,QCVVideoReciever_listen, "QCVVideoReciever_listen");
 
 procedure QCVVideoReciever_stopListen(handle:not null QCVVideoRecieverH);
 pragma Import(C,QCVVideoReciever_stopListen, "QCVVideoReciever_stopListen");
 
 function  QCVVideoReciever_imgData(handle:not null QCVVideoRecieverH) return QByteArrayH;
 pragma Import(C,QCVVideoReciever_imgData, "QCVVideoReciever_imgData");
 
 function  QCVVideoReciever_isWorkInProgress(handle:not null QCVVideoRecieverH) return boolean;
 pragma Import(C,QCVVideoReciever_isWorkInProgress, "QCVVideoReciever_isWorkInProgress");
 
 type QByteArrayCallbackH  is access procedure(prm:QByteArrayH);
 pragma Convention(C,QByteArrayCallbackH);
  
 procedure QCVVideoReciever_signal_slot_imgDataReceived(handle:not null QCVVideoRecieverH;hook: QByteArrayCallbackH);
 pragma Import(C,QCVVideoReciever_signal_slot_imgDataReceived, "QCVVideoReciever_signal_slot_imgDataReceived");
 
 
 end;
