--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2021                           
--  Copyright (C) 2021                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;
with Qt.QString; use Qt.QString;
package Qt.QCVVideoTransmitter is

 function  QCVVideoTransmitter_create(host:QStringH := s2qs("localhost");port : quint16 :=  10000;parent : QObjectH :=  null) return QCVVideoTransmitterH;
 pragma Import(C,QCVVideoTransmitter_create, "QCVVideoTransmitter_create");
 
 procedure QCVVideoTransmitter_destroy(handle:not null QCVVideoTransmitterH);
 pragma Import(C,QCVVideoTransmitter_destroy, "QCVVideoTransmitter_destroy");
 
 procedure QCVVideoTransmitter_setQuality(handle:not null QCVVideoTransmitterH;quality:integer);
 pragma Import(C,QCVVideoTransmitter_setQuality, "QCVVideoTransmitter_setQuality");
 
 procedure QCVVideoTransmitter_host(handle:not null QCVVideoTransmitterH;host:QStringH);
 pragma Import(C,QCVVideoTransmitter_host, "QCVVideoTransmitter_host");
 
 procedure QCVVideoTransmitter_port(handle:not null QCVVideoTransmitterH;port:quint16);
 pragma Import(C,QCVVideoTransmitter_port, "QCVVideoTransmitter_port");
 
 procedure QCVVideoTransmitter_packetSize(handle:not null QCVVideoTransmitterH;size: integer);
 pragma Import(C,QCVVideoTransmitter_packetSize, "QCVVideoTransmitter_packetSize");
 
 procedure QCVVideoTransmitter_onError(handle:not null QCVVideoTransmitterH;err:QStringH);
 pragma Import(C,QCVVideoTransmitter_onError, "QCVVideoTransmitter_onError");
 
 procedure QCVVideoTransmitter_sendFrameData(handle:not null QCVVideoTransmitterH;frame: QCVMatH; quality: integer := 70);
 pragma Import(C,QCVVideoTransmitter_sendFrameData, "QCVVideoTransmitter_sendFrameData");
  
 procedure QCVVideoTransmitter_signal_slot_onError(handle:not null QCVVideoTransmitterH;hook:QStringCallbackH);
 pragma Import(C,QCVVideoTransmitter_signal_slot_onError, "QCVVideoTransmitter_signal_slot_onError");

end;
