--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2022                                                
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;
with Qt.QString; use Qt.QString;
package Qt.QCVYOLOV is

 yolov6IterateRows : constant := 8400;
 yolov5IterateRows : constant := 25200;

 function  QCVYOLOV_detector(frame: not null QCVMatH;net: QCVNetH; classNames :QStringH := s2qs("models/coco.names")) return QCVMatH;
 pragma Import(C,QCVYOLOV_detector, "QCVYOLOV_detector");
 
 -- list of rects
 function  QCVYOLOV_findObjects return QCVMatListH;
 pragma Import(C,QCVYOLOV_findObjects, "QCVYOLOV_findObjects");
 
 procedure QCVYOLOV_setYolov5Rows;
 pragma Import(C,QCVYOLOV_setYolov5Rows, "QCVYOLOV_setYolov5Rows");
 
 procedure QCVYOLOV_setYolov6Rows;
 pragma Import(C,QCVYOLOV_setYolov6Rows, "QCVYOLOV_setYolov6Rows");
 
end;
