--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;  use Qt.OpenCV;
with Qt.QString; use Qt.QString;
package Qt.QCVYolox is

 type QCVYoloxH  is new QObjectH;

 function  QCVYolox_create(confThreshold,nmsThreshold: float;modelpath:QStringH;classesFile:QStringH) return QCVYoloxH;
 pragma Import(C,QCVYolox_create, "QCVYolox_create");
 
 procedure QCVYolox_detect(handle:not null QCVYoloxH;srcimg: not null QCVMatH);
 pragma Import(C,QCVYolox_detect, "QCVYolox_detect");
 
-- function  QCVYolox_net(handle:not null QCVYoloxH) return QCVNetH;
-- pragma Import(C,QCVYolox_net, "QCVYolox_net");
 
 function  QCVYolox_resizeImage(handle:not null QCVYoloxH;srcimg:QCVMatH;scale: in out float) return QCVMatH;
 pragma Import(C,QCVYolox_resizeImage, "QCVYolox_resizeImage");
 
 procedure QCVYolox_normalize(handle:not null QCVYoloxH;img:QCVMatH);
 pragma Import(C,QCVYolox_normalize, "QCVYolox_normalize");
 
 function  QCVYolox_getMaxClass(handle:not null QCVYoloxH;scores:QFloatListH) return integer;
 pragma Import(C,QCVYolox_getMaxClass, "QCVYolox_getMaxClass");
 
 function  QCVYolox_getPerfProfile(handle:not null QCVYoloxH;layersTimes:QDoubleListH) return double;
 pragma Import(C,QCVYolox_getPerfProfile, "QCVYolox_getPerfProfile");
 
end;
