--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

package body Qt.QOCRTessBaseAPI is
 
 procedure QOCRTessBaseAPI_SetImage(handle:not null QCVTessBaseAPIH;imagedata:QByteArrayH;width,height,bytes_per_pixel,bytes_per_line: integer) is
 begin
  QOCRTessBaseAPI_SetImage2(handle,imagedata,width,height,bytes_per_pixel,bytes_per_line);
 end;

 function  QOCRTessBaseAPI_GetUTF8Text(handle:not null QCVTessBaseAPIH) return zstring is
 begin
   return QOCRTessBaseAPI_GetUTF8Text2(handle);
 end;

 function  QOCRTessBaseAPI_GetHOCRText(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH;page_number: integer) return QStringH is
 begin
   return  QOCRTessBaseAPI_GetHOCRText2(handle,monitor,page_number);
 end;

 function  QOCRTessBaseAPI_GetAltoText(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH;page_number: integer) return QStringH is
 begin
   return  QOCRTessBaseAPI_GetAltoText2(handle,monitor,page_number);
 end;

 procedure QOCRTessBaseAPI_SetImage(handle:not null QCVTessBaseAPIH;pix:QCVPixH) is
 begin
   QOCRTessBaseAPI_SetImage3(handle,pix);
 end;

 function  QOCRTessBaseAPI_GetTextlines(handle:not null QCVTessBaseAPIH;raw_image:boolean;raw_padding: integer;pixa: void_star;blockids: void_star;paraids: void_Star) return QCVBoxaH is
 begin
   return  QOCRTessBaseAPI_GetTextlines2(handle,raw_image,raw_padding,pixa,blockids,paraids);
 end;

 function  QOCRTessBaseAPI_GetComponentImages(handle:not null QCVTessBaseAPIH;level:PageIteratorLevel;text_only: boolean;raw_image: boolean;raw_padding: integer;pixa: void_Star;blockids:void_Star;paraids: void_Star) return QCVBoxaH is
 begin
   return  QOCRTessBaseAPI_GetComponentImages2(handle,level,text_only,raw_image,raw_padding,pixa,blockids,paraids);
 end;

 function  QOCRTessBaseAPI_AnalyseLayout(handle:not null QCVTessBaseAPIH;merge_similar_words:boolean) return QCVPageIteratorH is
 begin
   return  QOCRTessBaseAPI_AnalyseLayout2(handle,merge_similar_words);
 end;

 function  QOCRTessBaseAPI_Init(handle:not null QCVTessBaseAPIH;datapath:QStringH;language: QStringH;mode: OcrEngineMode;configs: QStringListH;configs_size: integer;vars_vec: QStringListH;vars_values:QStringListH;set_only_non_debug_params:boolean) return integer is
 begin
   return  QOCRTessBaseAPI_Init2(handle,datapath,language,mode,configs,configs_size,vars_vec,vars_values,set_only_non_debug_params);
 end;

 function  QOCRTessBaseAPI_Init(handle:not null QCVTessBaseAPIH;data:QStringH;data_size: integer;language: QStringH;mode: OcrEngineMode;configs: QStringListH;configs_size: integer;vars_vec:QStringListH;vars_values:QStringListH;set_only_non_debug_params:boolean;reader:QCVFileReaderH) return integer is
 begin
   return  QOCRTessBaseAPI_Init3(handle,data,data_size,language,mode,configs,configs_size,vars_vec,vars_values,set_only_non_debug_params,reader);
 end;

end;
