--
-- ͻ
--        D E S I G N   E N G I N E E R I N G            DS        
--             S O F T W A R E                           ͼ        
--                                                                    
--         QtOpenCVAda - Ada to Qt6 and OpenCV interface              
--                                                                    
--         Author :  Leonid Dulman     2022                           
--  Copyright (C) 2012,2022                                           
-- ͼ
--
--   This library is free software; you can redistribute it and/or modify  *
--   it under the terms of the GNU Library General Public License as       *
--   published by the Free Software Foundation; either version 3 of the    *
--   License, or (at your option) any later version.                       *

with Qt.OpenCV;          use Qt.OpenCV;
with Qt.QOCRPublicTypes; use Qt.QOCRPublicTypes;
with builtin; use builtin;
package Qt.QOCRTessBaseAPI is

 function  QOCRTessBaseAPI_create return QCVTessBaseAPIH;
 pragma Import(C,QOCRTessBaseAPI_create, "QOCRTessBaseAPI_create");
 
 procedure QOCRTessBaseAPI_destroy(handle:not null QCVTessBaseAPIH);
 pragma Import(C,QOCRTessBaseAPI_destroy, "QOCRTessBaseAPI_destroy");
 
 function  QOCRTessBaseAPI_Version return QStringH;
 pragma Import(C,QOCRTessBaseAPI_Version, "QOCRTessBaseAPI_Version");
 
 function  QOCRTessBaseAPI_getOpenCLDevice(device:void_Star) return qint64;
 pragma Import(C,QOCRTessBaseAPI_getOpenCLDevice, "QOCRTessBaseAPI_getOpenCLDevice");
 
 procedure QOCRTessBaseAPI_SetInputName(handle:not null QCVTessBaseAPIH;name:QStringH);
 pragma Import(C,QOCRTessBaseAPI_SetInputName, "QOCRTessBaseAPI_SetInputName");
 
 function  QOCRTessBaseAPI_GetInputName(handle:not null QCVTessBaseAPIH) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetInputName, "QOCRTessBaseAPI_GetInputName");
 
 procedure QOCRTessBaseAPI_SetInputImage(handle:not null QCVTessBaseAPIH;pix:QCVPixH);
 pragma Import(C,QOCRTessBaseAPI_SetInputImage, "QOCRTessBaseAPI_SetInputImage");
 
 function  QOCRTessBaseAPI_GetInputImage(handle:not null QCVTessBaseAPIH) return QCVPixH;
 pragma Import(C,QOCRTessBaseAPI_GetInputImage, "QOCRTessBaseAPI_GetInputImage");
 
 function  QOCRTessBaseAPI_GetSourceYResolution(handle:not null QCVTessBaseAPIH) return integer;
 pragma Import(C,QOCRTessBaseAPI_GetSourceYResolution, "QOCRTessBaseAPI_GetSourceYResolution");
 
 function  QOCRTessBaseAPI_GetDatapath(handle:not null QCVTessBaseAPIH) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetDatapath, "QOCRTessBaseAPI_GetDatapath");
 
 procedure QOCRTessBaseAPI_SetOutputName(handle:not null QCVTessBaseAPIH;name:QStringH);
 pragma Import(C,QOCRTessBaseAPI_SetOutputName, "QOCRTessBaseAPI_SetOutputName");
 
 function  QOCRTessBaseAPI_SetVariable(handle:not null QCVTessBaseAPIH;name:QStringH;value: QStringH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_SetVariable, "QOCRTessBaseAPI_SetVariable");
 
 function  QOCRTessBaseAPI_SetDebugVariable(handle:not null QCVTessBaseAPIH;name:QStringH;value: QStringH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_SetDebugVariable, "QOCRTessBaseAPI_SetDebugVariable");
 
 function  QOCRTessBaseAPI_GetIntVariable(handle:not null QCVTessBaseAPIH;name:QStringH;value: in out integer) return boolean;
 pragma Import(C,QOCRTessBaseAPI_GetIntVariable, "QOCRTessBaseAPI_GetIntVariable");
 
 function  QOCRTessBaseAPI_GetBoolVariable(handle:not null QCVTessBaseAPIH;name:QStringH;value: in out boolean) return boolean;
 pragma Import(C,QOCRTessBaseAPI_GetBoolVariable, "QOCRTessBaseAPI_GetBoolVariable");
 
 function  QOCRTessBaseAPI_GetDoubleVariable(handle:not null QCVTessBaseAPIH;name:QStringH;value: in out double) return boolean;
 pragma Import(C,QOCRTessBaseAPI_GetDoubleVariable, "QOCRTessBaseAPI_GetDoubleVariable");
 
 function  QOCRTessBaseAPI_GetStringVariable(handle:not null QCVTessBaseAPIH;name:QStringH) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetStringVariable, "QOCRTessBaseAPI_GetStringVariable");
 
 procedure QOCRTessBaseAPI_PrintegerFontsTable(handle:not null QCVTessBaseAPIH;fp:QCVFILEH);
 pragma Import(C,QOCRTessBaseAPI_PrintegerFontsTable, "QOCRTessBaseAPI_PrintegerFontsTable");
 
 procedure QOCRTessBaseAPI_PrintegerVariables(handle:not null QCVTessBaseAPIH;fp:QCVFILEH);
 pragma Import(C,QOCRTessBaseAPI_PrintegerVariables, "QOCRTessBaseAPI_PrintegerVariables");
 
 function  QOCRTessBaseAPI_GetVariableAsString(handle:not null QCVTessBaseAPIH;name:QStringH;val: QStringH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_GetVariableAsString, "QOCRTessBaseAPI_GetVariableAsString");
 
 function  QOCRTessBaseAPI_Init(handle:not null QCVTessBaseAPIH;datapath:QStringH;language: QStringH;oem: OcrEngineMode) return integer;
 pragma Import(C,QOCRTessBaseAPI_Init, "QOCRTessBaseAPI_Init");
 
 function  QOCRTessBaseAPI_Init2(handle:not null QCVTessBaseAPIH;datapath:QStringH;language: QStringH;mode: OcrEngineMode;configs: QStringListH;configs_size: integer;vars_vec: QStringListH;vars_values:QStringListH;set_only_non_debug_params:boolean) return integer;
 pragma Import(C,QOCRTessBaseAPI_Init2, "QOCRTessBaseAPI_Init2");
 
 function  QOCRTessBaseAPI_Init3(handle:not null QCVTessBaseAPIH;data:QStringH;data_size: integer;language: QStringH;mode: OcrEngineMode;configs: QStringListH;configs_size: integer;vars_vec:QStringListH;vars_values:QStringListH;set_only_non_debug_params:boolean;reader:QCVFileReaderH) return integer;
 pragma Import(C,QOCRTessBaseAPI_Init3, "QOCRTessBaseAPI_Init3");
  
 function  QOCRTessBaseAPI_GetPageSegMode(handle:not null QCVTessBaseAPIH) return PageSegMode;
 pragma Import(C,QOCRTessBaseAPI_GetPageSegMode, "QOCRTessBaseAPI_GetPageSegMode");
 
 function  QOCRTessBaseAPI_TesseractRect(handle:not null QCVTessBaseAPIH;imagedata:QByteArrayH;bytes_per_pixel,bytes_per_line,left,top,width,height:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_TesseractRect, "QOCRTessBaseAPI_TesseractRect");
 
 procedure QOCRTessBaseAPI_ClearAdaptiveClassifier(handle:not null QCVTessBaseAPIH);
 pragma Import(C,QOCRTessBaseAPI_ClearAdaptiveClassifier, "QOCRTessBaseAPI_ClearAdaptiveClassifier");
 
 function  QOCRTessBaseAPI_GetInitLanguagesAsString(handle:not null QCVTessBaseAPIH) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetInitLanguagesAsString, "QOCRTessBaseAPI_GetInitLanguagesAsString");
 
 procedure QOCRTessBaseAPI_GetLoadedLanguagesAsVector(handle:not null QCVTessBaseAPIH;langs:QStringListH);
 pragma Import(C,QOCRTessBaseAPI_GetLoadedLanguagesAsVector, "QOCRTessBaseAPI_GetLoadedLanguagesAsVector");
 
 procedure QOCRTessBaseAPI_GetAvailableLanguagesAsVector(handle:not null QCVTessBaseAPIH;langs:QStringListH);
 pragma Import(C,QOCRTessBaseAPI_GetAvailableLanguagesAsVector, "QOCRTessBaseAPI_GetAvailableLanguagesAsVector");
 
 procedure QOCRTessBaseAPI_InitForAnalysePage(handle:not null QCVTessBaseAPIH);
 pragma Import(C,QOCRTessBaseAPI_InitForAnalysePage, "QOCRTessBaseAPI_InitForAnalysePage");
 
 procedure QOCRTessBaseAPI_ReadConfigFile(handle:not null QCVTessBaseAPIH;fileName:QStringH);
 pragma Import(C,QOCRTessBaseAPI_ReadConfigFile, "QOCRTessBaseAPI_ReadConfigFile");
 
 procedure QOCRTessBaseAPI_ReadDebugConfigFile(handle:not null QCVTessBaseAPIH;fileName:QStringH);
 pragma Import(C,QOCRTessBaseAPI_ReadDebugConfigFile, "QOCRTessBaseAPI_ReadDebugConfigFile");
  
 procedure QOCRTessBaseAPI_SetImage(handle:not null QCVTessBaseAPIH;imagedata:QCVMatH;bytes_per_pixel:integer);
 pragma Import(C,QOCRTessBaseAPI_SetImage, "QOCRTessBaseAPI_SetImage");
 
 procedure QOCRTessBaseAPI_SetImage2(handle:not null QCVTessBaseAPIH;imagedata:QByteArrayH;width,height,bytes_per_pixel,bytes_per_line: integer);
 pragma Import(C,QOCRTessBaseAPI_SetImage2, "QOCRTessBaseAPI_SetImage2");
 ----------------------------------------------------------------------------------
 procedure QOCRTessBaseAPI_SetImage3(handle:not null QCVTessBaseAPIH;pix:QCVPixH);
 pragma Import(C,QOCRTessBaseAPI_SetImage3, "QOCRTessBaseAPI_SetImage3");
 
 procedure QOCRTessBaseAPI_SetSourceResolution(handle:not null QCVTessBaseAPIH;ppi:integer);
 pragma Import(C,QOCRTessBaseAPI_SetSourceResolution, "QOCRTessBaseAPI_SetSourceResolution");
 
 procedure QOCRTessBaseAPI_SetRectangle(handle:not null QCVTessBaseAPIH;left:integer;top: integer;width: integer;height: integer);
 pragma Import(C,QOCRTessBaseAPI_SetRectangle, "QOCRTessBaseAPI_SetRectangle");
 
 function  QOCRTessBaseAPI_GetThresholdedImage(handle:not null QCVTessBaseAPIH) return QCVPixH;
 pragma Import(C,QOCRTessBaseAPI_GetThresholdedImage, "QOCRTessBaseAPI_GetThresholdedImage");
 
 function  QOCRTessBaseAPI_GetRegions(handle:not null QCVTessBaseAPIH;pixa:void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetRegions, "QOCRTessBaseAPI_GetRegions");
 
 function  QOCRTessBaseAPI_GetTextlines(handle:not null QCVTessBaseAPIH;pixa:void_star;blockids: void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetTextlines, "QOCRTessBaseAPI_GetTextlines");
 
 function  QOCRTessBaseAPI_GetTextlines2(handle:not null QCVTessBaseAPIH;raw_image:boolean;raw_padding: integer;pixa: void_star;blockids: void_star;paraids: void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetTextlines2, "QOCRTessBaseAPI_GetTextlines2");
 
 function  QOCRTessBaseAPI_GetStrips(handle:not null QCVTessBaseAPIH;pixa:void_Star;blockids: void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetStrips, "QOCRTessBaseAPI_GetStrips");
 
 function  QOCRTessBaseAPI_GetWords(handle:not null QCVTessBaseAPIH;pixa:void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetWords, "QOCRTessBaseAPI_GetWords");
 
 function  QOCRTessBaseAPI_GetConnectedComponents(handle:not null QCVTessBaseAPIH;cc:void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetConnectedComponents, "QOCRTessBaseAPI_GetConnectedComponents");
 
 function  QOCRTessBaseAPI_GetComponentImages(handle:not null QCVTessBaseAPIH;level:PageIteratorLevel;text_only:boolean;pixa:void_Star;blockids: void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetComponentImages, "QOCRTessBaseAPI_GetComponentImages");
 
 function  QOCRTessBaseAPI_GetComponentImages2(handle:not null QCVTessBaseAPIH;level:PageIteratorLevel;text_only: boolean;raw_image: boolean;raw_padding: integer;pixa: void_Star;blockids:void_Star;paraids: void_Star) return QCVBoxaH;
 pragma Import(C,QOCRTessBaseAPI_GetComponentImages2, "QOCRTessBaseAPI_GetComponentImages2");
 
 function  QOCRTessBaseAPI_GetThresholdedImageScaleFactor(handle:not null QCVTessBaseAPIH) return integer;
 pragma Import(C,QOCRTessBaseAPI_GetThresholdedImageScaleFactor, "QOCRTessBaseAPI_GetThresholdedImageScaleFactor");
 
 function  QOCRTessBaseAPI_AnalyseLayout(handle:not null QCVTessBaseAPIH) return QCVPageIteratorH;
 pragma Import(C,QOCRTessBaseAPI_AnalyseLayout, "QOCRTessBaseAPI_AnalyseLayout");
 
 function  QOCRTessBaseAPI_AnalyseLayout2(handle:not null QCVTessBaseAPIH;merge_similar_words:boolean) return QCVPageIteratorH;
 pragma Import(C,QOCRTessBaseAPI_AnalyseLayout2, "QOCRTessBaseAPI_AnalyseLayout2");
 
 function  QOCRTessBaseAPI_Recognize(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH) return integer;
 pragma Import(C,QOCRTessBaseAPI_Recognize, "QOCRTessBaseAPI_Recognize");
 
 function  QOCRTessBaseAPI_ProcessPages(handle:not null QCVTessBaseAPIH;filename:QStringH;retry_config:QStringH;timeout_millisec:integer;renderer: QCVTessResultRendererH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_ProcessPages, "QOCRTessBaseAPI_ProcessPages");
 
 function  QOCRTessBaseAPI_ProcessPagesInternal(handle:not null QCVTessBaseAPIH;filename:QStringH;retry_config:QStringH;timeout_millisec: integer;renderer: QCVTessResultRendererH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_ProcessPagesInternal, "QOCRTessBaseAPI_ProcessPagesInternal");
 
 function  QOCRTessBaseAPI_ProcessPage(handle:not null QCVTessBaseAPIH;pix:QCVPixH;page_index: integer;filename: QStringH;retry_config: QStringH;timeout_millisec: integer;renderer: QCVTessResultRendererH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_ProcessPage, "QOCRTessBaseAPI_ProcessPage");
 
 function  QOCRTessBaseAPI_GetIterator(handle:not null QCVTessBaseAPIH) return QCVResultIteratorH;
 pragma Import(C,QOCRTessBaseAPI_GetIterator, "QOCRTessBaseAPI_GetIterator");
 
 function  QOCRTessBaseAPI_GetMutableIterator(handle:not null QCVTessBaseAPIH) return QCVMutableIteratorH;
 pragma Import(C,QOCRTessBaseAPI_GetMutableIterator, "QOCRTessBaseAPI_GetMutableIterator");
 
 ------------------------------------------------------------------------------------
 procedure QOCRTessBaseAPI_SetPageSegMode(handle:not null QCVTessBaseAPIH;mode:PageSegMode);
 pragma Import(C,QOCRTessBaseAPI_SetPageSegMode, "QOCRTessBaseAPI_SetPageSegMode");
 
 function  QOCRTessBaseAPI_GetUTF8Text(handle:not null QCVTessBaseAPIH) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetUTF8Text, "QOCRTessBaseAPI_GetUTF8Text");
 
 function  QOCRTessBaseAPI_GetUTF8Text2(handle:not null QCVTessBaseAPIH) return zstring;
 pragma Import(C,QOCRTessBaseAPI_GetUTF8Text2, "QOCRTessBaseAPI_GetUTF8Text2");
 ------------------------------------------------------------------------------------------
 function  QOCRTessBaseAPI_GetHOCRText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetHOCRText, "QOCRTessBaseAPI_GetHOCRText");
 
 function  QOCRTessBaseAPI_GetHOCRText2(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH;page_number: integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetHOCRText2, "QOCRTessBaseAPI_GetHOCRText2");
 
 function  QOCRTessBaseAPI_GetAltoText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetAltoText, "QOCRTessBaseAPI_GetAltoText");
 
 function  QOCRTessBaseAPI_GetAltoText2(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH;page_number: integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetAltoText2, "QOCRTessBaseAPI_GetAltoText2");
 
 function  QOCRTessBaseAPI_GetTSVText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetTSVText, "QOCRTessBaseAPI_GetTSVText");
 
 function  QOCRTessBaseAPI_GetLSTMBoxText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetLSTMBoxText, "QOCRTessBaseAPI_GetLSTMBoxText");
 
 function  QOCRTessBaseAPI_GetBoxText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetBoxText, "QOCRTessBaseAPI_GetBoxText");
 
 function  QOCRTessBaseAPI_GetWordStrBoxText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetWordStrBoxText, "QOCRTessBaseAPI_GetWordStrBoxText");
 
 function  QOCRTessBaseAPI_GetUNLVText(handle:not null QCVTessBaseAPIH) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetUNLVText, "QOCRTessBaseAPI_GetUNLVText");
 
 function  QOCRTessBaseAPI_DetectOrientationScript(handle:not null QCVTessBaseAPIH;orient_deg:in out integer;orient_conf: in out float; script_name:void_Star;script_conf: in out float) return boolean;
 pragma Import(C,QOCRTessBaseAPI_DetectOrientationScript, "QOCRTessBaseAPI_DetectOrientationScript");
 
 function  QOCRTessBaseAPI_GetOsdText(handle:not null QCVTessBaseAPIH;page_number:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetOsdText, "QOCRTessBaseAPI_GetOsdText");
 
 function  QOCRTessBaseAPI_MeanTextConf(handle:not null QCVTessBaseAPIH) return integer;
 pragma Import(C,QOCRTessBaseAPI_MeanTextConf, "QOCRTessBaseAPI_MeanTextConf");
 
 function  QOCRTessBaseAPI_AllWordConfidences(handle:not null QCVTessBaseAPIH) return pinteger;
 pragma Import(C,QOCRTessBaseAPI_AllWordConfidences, "QOCRTessBaseAPI_AllWordConfidences");
 
 function  QOCRTessBaseAPI_AdaptToWordStr(handle:not null QCVTessBaseAPIH;mode:PageSegMode;wordstr: QStringH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_AdaptToWordStr, "QOCRTessBaseAPI_AdaptToWordStr");
 
 ------------------------------------------------------------------------------------------
 procedure QOCRTessBaseAPI_Clear(handle:not null QCVTessBaseAPIH);
 pragma Import(C,QOCRTessBaseAPI_Clear, "QOCRTessBaseAPI_Clear");
 
 procedure QOCRTessBaseAPI_End(handle:not null QCVTessBaseAPIH);
 pragma Import(C,QOCRTessBaseAPI_End, "QOCRTessBaseAPI_End");
 
 procedure QOCRTessBaseAPI_ClearPersistentCache;
 pragma Import(C,QOCRTessBaseAPI_ClearPersistentCache, "QOCRTessBaseAPI_ClearPersistentCache");
 
 function  QOCRTessBaseAPI_IsValidWord(handle:not null QCVTessBaseAPIH;word:QStringH) return integer;
 pragma Import(C,QOCRTessBaseAPI_IsValidWord, "QOCRTessBaseAPI_IsValidWord");
 
 function  QOCRTessBaseAPI_IsValidCharacter(handle:not null QCVTessBaseAPIH;utf8_character:QStringH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_IsValidCharacter, "QOCRTessBaseAPI_IsValidCharacter");
 
 function  QOCRTessBaseAPI_GetTextDirection(handle:not null QCVTessBaseAPIH;Hout_offset:integer;out_slope: in out float) return boolean;
 pragma Import(C,QOCRTessBaseAPI_GetTextDirection, "QOCRTessBaseAPI_GetTextDirection");
 
 procedure QOCRTessBaseAPI_SetDictFunc(handle:not null QCVTessBaseAPIH;f:QCVDictFuncH);
 pragma Import(C,QOCRTessBaseAPI_SetDictFunc, "QOCRTessBaseAPI_SetDictFunc");
 
 procedure QOCRTessBaseAPI_SetProbabilityInContextFunc(handle:not null QCVTessBaseAPIH;f:QCVProbabilityInContextFuncH);
 pragma Import(C,QOCRTessBaseAPI_SetProbabilityInContextFunc, "QOCRTessBaseAPI_SetProbabilityInContextFunc");
 
 function  QOCRTessBaseAPI_DetectOS(handle:not null QCVTessBaseAPIH;os:QCVOSResultsH) return boolean;
 pragma Import(C,QOCRTessBaseAPI_DetectOS, "QOCRTessBaseAPI_DetectOS");
 
 procedure QOCRTessBaseAPI_GetBlockTextOrientations(handle:not null QCVTessBaseAPIH;block_orientation:void_Star;vertical_writing: void_Star);
 pragma Import(C,QOCRTessBaseAPI_GetBlockTextOrientations, "QOCRTessBaseAPI_GetBlockTextOrientations");
 
 function  QOCRTessBaseAPI_GetUnichar(handle:not null QCVTessBaseAPIH;unichar_id:integer) return QStringH;
 pragma Import(C,QOCRTessBaseAPI_GetUnichar, "QOCRTessBaseAPI_GetUnichar");
 
 function  QOCRTessBaseAPI_GetDawg(handle:not null QCVTessBaseAPIH;i:integer) return QCVDawgH;
 pragma Import(C,QOCRTessBaseAPI_GetDawg, "QOCRTessBaseAPI_GetDawg");
 
 function  QOCRTessBaseAPI_NumDawgs(handle:not null QCVTessBaseAPIH) return integer;
 pragma Import(C,QOCRTessBaseAPI_NumDawgs, "QOCRTessBaseAPI_NumDawgs");
 
 function  QOCRTessBaseAPI_tesseract(handle:not null QCVTessBaseAPIH) return QCVTesseractH;
 pragma Import(C,QOCRTessBaseAPI_tesseract, "QOCRTessBaseAPI_tesseract");
 
 function  QOCRTessBaseAPI_oem(handle:not null QCVTessBaseAPIH) return OcrEngineMode;
 pragma Import(C,QOCRTessBaseAPI_oem, "QOCRTessBaseAPI_oem");
 
 procedure QOCRTessBaseAPI_set_min_orientation_margin(handle:not null QCVTessBaseAPIH;margin:double);
 pragma Import(C,QOCRTessBaseAPI_set_min_orientation_margin, "QOCRTessBaseAPI_set_min_orientation_margin");
 

----------------------------------------------------------------------
 procedure QOCRTessBaseAPI_SetImage(handle:not null QCVTessBaseAPIH;imagedata:QByteArrayH;width,height,bytes_per_pixel,bytes_per_line: integer);
 function  QOCRTessBaseAPI_GetUTF8Text(handle:not null QCVTessBaseAPIH) return zstring;
 function  QOCRTessBaseAPI_GetHOCRText(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH;page_number: integer) return QStringH;
 function  QOCRTessBaseAPI_GetAltoText(handle:not null QCVTessBaseAPIH;monitor:QCVETEXT_DESCH;page_number: integer) return QStringH;
 procedure QOCRTessBaseAPI_SetImage(handle:not null QCVTessBaseAPIH;pix:QCVPixH);
 function  QOCRTessBaseAPI_GetTextlines(handle:not null QCVTessBaseAPIH;raw_image:boolean;raw_padding: integer;pixa: void_star;blockids: void_star;paraids: void_Star) return QCVBoxaH;
 function  QOCRTessBaseAPI_GetComponentImages(handle:not null QCVTessBaseAPIH;level:PageIteratorLevel;text_only: boolean;raw_image: boolean;raw_padding: integer;pixa: void_Star;blockids:void_Star;paraids: void_Star) return QCVBoxaH;
 function  QOCRTessBaseAPI_AnalyseLayout(handle:not null QCVTessBaseAPIH;merge_similar_words:boolean) return QCVPageIteratorH;
 function  QOCRTessBaseAPI_Init(handle:not null QCVTessBaseAPIH;datapath:QStringH;language: QStringH;mode: OcrEngineMode;configs: QStringListH;configs_size: integer;vars_vec: QStringListH;vars_values:QStringListH;set_only_non_debug_params:boolean) return integer;
 function  QOCRTessBaseAPI_Init(handle:not null QCVTessBaseAPIH;data:QStringH;data_size: integer;language: QStringH;mode: OcrEngineMode;configs: QStringListH;configs_size: integer;vars_vec:QStringListH;vars_values:QStringListH;set_only_non_debug_params:boolean;reader:QCVFileReaderH) return integer;

end;
